SystemOrganization addCategory: #'Glamour-Tests-Core'!

GLMTransmission subclass: #GLMMockSimpleTransmission
	instanceVariableNames: 'wasTransmited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMMockSimpleTransmission classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/2/2009 21:24'!
new

	^super new initialize! !

!GLMMockSimpleTransmission methodsFor: 'tests' stamp: 'tg 1/14/2010 16:08'!
initialize
	super initialize.
	wasTransmited := false! !

!GLMMockSimpleTransmission methodsFor: 'tests' stamp: 'jorge.ressia 6/2/2009 21:26'!
transmit

	wasTransmited := true.
	super transmit.! !

!GLMMockSimpleTransmission methodsFor: 'tests' stamp: 'jre 9/18/2009 21:45'!
transmitIn: aContext

	wasTransmited := true.
	super transmitIn: aContext! !

!GLMMockSimpleTransmission methodsFor: 'tests' stamp: 'jorge.ressia 6/2/2009 21:23'!
wasTransmited
	^wasTransmited! !

GLMPane subclass: #GLMTestPane
	instanceVariableNames: 'seenTransmissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMTestPane classSide methodsFor: 'private' stamp: 'jorge.ressia 6/3/2009 08:55'!
new

	^super new initialize! !

!GLMTestPane classSide methodsFor: 'private' stamp: ' 4/5/09 22:18'!
portClass 
	 
	^GLMTestPort! !

!GLMTestPane methodsFor: 'accessing' stamp: 'tg 1/11/2010 21:59'!
browser
	browser isNil ifTrue: [ ^ GLMNoBrowser new ].
	^ browser! !

!GLMTestPane methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:37'!
browser: aBrowser 
	browser := aBrowser! !

!SubscriptionRegistry methodsFor: '*glamour-tests-core' stamp: 'TudorGirba 5/18/2011 13:14'!
glmSubscriptions
	^ subscriptions! !

Announcement subclass: #TestAnnouncement
	instanceVariableNames: 'parameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!TestAnnouncement methodsFor: 'accessing' stamp: 'tg 2/22/2010 11:13'!
parameter
	^ parameter! !

!TestAnnouncement methodsFor: 'accessing' stamp: 'tg 2/22/2010 11:13'!
parameter: anObject
	parameter := anObject! !

GLMPanePort subclass: #GLMTestPort
	instanceVariableNames: 'seenTransmissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMTestPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
receive: aTransmission 
	 
	self seenTransmissions addLast: aTransmission. 
	^super receive: aTransmission! !

!GLMTestPort methodsFor: 'accessing' stamp: 'TudorGirba 4/18/2011 18:23'!
receive: aTransmission in: aContext
	self seenTransmissions addLast: aTransmission. 
	^super receive: aTransmission in: aContext! !

!GLMTestPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
seenTransmissions 
	 
	^seenTransmissions ifNil: [seenTransmissions := OrderedCollection new]! !

TestCase subclass: #GLMAccumulatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'TudorGirba 5/20/2012 00:53'!
testCopy
	| accumulator presentation copiedAccumulator |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	(accumulator transmit)
		fromOutsidePort: #selection;
		toOutsidePort: #otherPort.
	copiedAccumulator := accumulator copy.
	self assert: copiedAccumulator transmissions size equals: 1.
	self assert: copiedAccumulator transmissions first ~~ accumulator transmissions first.
	self assert: copiedAccumulator transmissions first destination pane == copiedAccumulator pane.
	self assert: copiedAccumulator transmissions first origins first pane ~~ accumulator pane.
	self assert: copiedAccumulator transmissions first origins first pane == copiedAccumulator pane! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'TudorGirba 5/20/2012 00:53'!
testCustomTransmissions
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	(accumulator transmit)
		fromOutsidePort: #selection;
		toOutsidePort: #otherPort.
	accumulator startOn: 41.
	(accumulator panes first port: #selection) value: 42.
	self assert: (accumulator pane port: #otherPort) value equals: 42! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testNoDuplicatePaneCreation
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator entity: 41.
	self assert: accumulator panes size equals: 1.
	accumulator entity: 42.
	self assert: accumulator panes size equals: 2.
	accumulator entity: 41.
	self assert: accumulator panes size equals: 2! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneAddedAnnouncement
	| accumulator presentation annoumcementsCount |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	annoumcementsCount := 0.
	accumulator on: GLMPaneAdded do: [ :ann | annoumcementsCount := annoumcementsCount + 1 ].
	1 to: 42 do: [ :i | accumulator entity: i ].
	self assert: annoumcementsCount equals: 42! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneCreation
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator entity: 41.
	self assert: accumulator panes size equals: 1.
	self assert: (accumulator panes first port: #entity) value equals: 41.
	self assert: accumulator panes first presentations first rootPrototype == presentation.
	accumulator entity: 42.
	self assert: accumulator panes size equals: 2.
	self assert: (accumulator panes first port: #entity) value equals: 41.
	self assert: (accumulator panes last port: #entity) value equals: 42.
	self assert: accumulator panes first presentations first rootPrototype equals: presentation.
	self assert: accumulator panes last presentations first rootPrototype equals: presentation! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneName
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator entity: 41.
	self assert: accumulator panes first name equals: '1'.
	accumulator entity: 42.
	self assert: accumulator panes last name equals: '2'! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneRemovedAnnouncement
	| accumulator presentation annoumcementsCount |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	annoumcementsCount := 0.
	accumulator on: GLMPaneRemoved do: [ :ann | annoumcementsCount := annoumcementsCount + 1 ].
	1 to: 42 do: [ :i | accumulator entity: i ].
	self assert: annoumcementsCount equals: 0.
	1 to: 42 do: [ :i | accumulator removePaneIndex: 1 ].
	self assert: annoumcementsCount equals: 42! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneSelectedAnnouncement
	| accumulator presentation annoumcementsCount otherAnnoumcementsCount |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	annoumcementsCount := 0.
	otherAnnoumcementsCount := 0.
	1 to: 42 do: [ :i | accumulator entity: i ].
	accumulator on: GLMPaneSelected do: [ :ann | annoumcementsCount := annoumcementsCount + 1 ].
	accumulator on: GLMPaneAdded do: [ :ann | otherAnnoumcementsCount := otherAnnoumcementsCount + 1 ].
	accumulator on: GLMPaneRemoved do: [ :ann | otherAnnoumcementsCount := otherAnnoumcementsCount + 1 ].
	self assert: annoumcementsCount equals: 0.
	self assert: otherAnnoumcementsCount equals: 0.
	1 to: 42 do: [ :i | accumulator entityToSelect: i ].
	self assert: annoumcementsCount equals: 42.
	self assert: otherAnnoumcementsCount equals: 0! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPublishToOutside
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator startOn: 41.
	(accumulator panes first port: #selection) value: 42.
	self assert: (accumulator pane port: #selection) value equals: 42! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPublishToOutsideWhenEmbedded
	| browser accumulator actualAccumulator |
	browser := GLMTabulator new.
	accumulator := GLMAccumulator new.
	accumulator addPresentation: GLMPresentation new.
	accumulator
		addTransmission:
			((GLMTransmission new)
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								presentation: accumulator;
								name: #selection;
								yourself);
				destination:
						((GLMPresentationBoundPort new)
								presentation: accumulator;
								name: #anotherPort;
								yourself);
				yourself).
	browser addColumn: #one.
	browser
		addTransmission:
			((GLMTransmission new)
				ensurePresentIfNoneStrategy;
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								presentation: browser;
								name: #entity;
								yourself);
				destination: ((browser paneNamed: #one) port: #entity);
				addPresentation: accumulator;
				yourself).
	browser startOn: 41.
	actualAccumulator := browser panes first presentations first.
	(actualAccumulator panes first port: #selection) value: 42.
	self assert: (actualAccumulator pane port: #selection) value equals: 42.
	self assert: (actualAccumulator pane port: #anotherPort) value notNil.
	self assert: (actualAccumulator pane port: #anotherPort) value equals: 42! !

!GLMAccumulatorTest methodsFor: 'tests' stamp: 'TudorGirba 7/23/2011 19:45'!
testRemovePaneIndex
	| accumulator presentation |
	accumulator := GLMAccumulator new.
	presentation := GLMPresentation new.
	accumulator addPresentation: presentation.
	accumulator entity: 42.
	accumulator entity: 43.
	accumulator removePaneIndex: 2.
	self assert: accumulator panes size = 1! !

TestCase subclass: #GLMActionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMActionTest methodsFor: 'tests' stamp: 'TudorGirba 4/22/2012 22:38'!
testShortcutAsString
	| action |
	action := GLMAction new.
	action shortcut: $i.
	self assert: action shortcutAsString = 'alt+i'.
	action shortcut: $I.
	self assert: action shortcutAsString = 'alt+shift+i'! !

TestCase subclass: #GLMAnnouncementPropagationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMAnnouncementPropagationTest methodsFor: 'setup' stamp: 'TudorGirba 10/9/2011 08:04'!
expectedFailures
	^ #(testEntityPropogationAnnouncements testSimplePropagation)! !

!GLMAnnouncementPropagationTest methodsFor: 'setup' stamp: 'tg 5/24/2010 17:26'!
setUp
	GLMLogger instance: GLMMemoryLogger new! !

!GLMAnnouncementPropagationTest methodsFor: 'setup' stamp: 'tg 5/24/2010 17:27'!
tearDown
	GLMLogger reset! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testEntityPropogationAnnouncements
	"This tests the order in which announcements are raised in nested browsers. 
 
	This is of importance as, in this test, we add a browser to a pane when a 
	certain port of that pane gets updated using a BundleTransmission but this 
	browser has a transmission from its #outer pane that refers to the same 
	port.  In such a case we want the presentation to be set first so that it can 
	be notified when the outer port changes. 
 
	This is a sister test to testEntityPropogation that ensures that the 
	announcements are raised in the right order and not redundantly."

	| browser1 browser2 |
	browser1 := (GLMTabulator new)
		title: '1';
		yourself.
	browser2 := (GLMTabulator new)
		title: '2';
		yourself.
	browser1 pane name: 'b1 parent pane'.
	browser1 column: #'b1-pane'.
	browser2 column: #'b2-pane'.
	self assert: browser1 pane presentations size equals: 1.
	self assert: browser1 pane presentations first == browser1.
	(browser1 transmit)
		to: #'b1-pane';
		andShow: [ :a | a custom: browser2 ].
	(browser2 transmit)
		to: #'b2-pane';
		andShow: [ :a | a text ].
	self assert: GLMLogger instance announcements copy isEmpty.
	browser1 startOn: 42.
	self assert: GLMLogger instance announcements copy size equals: 12.	"1. The outer browser's outer pane changes its value."
	self assert: ((GLMLogger instance announcements copy at: 1) isKindOf: GLMContextChanged).
	self assert: (GLMLogger instance announcements copy at: 1) presentation == browser1.
	self assert: (GLMLogger instance announcements copy at: 1) property equals: #entity.
	self assert: (GLMLogger instance announcements copy at: 1) value equals: 42.	"2. The jumpstart transmission of the outer browser is triggered, updating the presentations..."
	self assert: ((GLMLogger instance announcements copy at: 2) isKindOf: GLMPresentationsChanged).
	self assert: (GLMLogger instance announcements copy at: 2) pane == browser1 panes first.
	self assert: (GLMLogger instance announcements copy at: 2) oldPresentations isEmpty.
	self assert: (GLMLogger instance announcements copy at: 2) presentations size equals: 1.
	self assert: (GLMLogger instance announcements copy at: 2) presentations first equals: browser2.	"3. ...and then the context."
	self assert: ((GLMLogger instance announcements copy at: 3) isKindOf: GLMContextChanged).
	self assert: (GLMLogger instance announcements at: 3) presentation equals: browser2.
	self assert: (GLMLogger instance announcements at: 3) property equals: #entity.
	self assert: (GLMLogger instance announcements at: 3) value equals: 42.	"4. The jumpstart transmission of the inner browser is triggered, updating the presentations..."
	self assert: ((GLMLogger instance announcements at: 4) isKindOf: GLMPresentationsChanged).
	self assert: (GLMLogger instance announcements at: 4) pane == browser2 panes first.
	self assert: (GLMLogger instance announcements at: 4) oldPresentations isEmpty.
	self assert: (GLMLogger instance announcements at: 4) presentations size equals: 1.
	self assert: (GLMLogger instance announcements at: 4) presentations first isNil.	"5. ...and then the context."
	self assert: ((GLMLogger instance announcements at: 5) isKindOf: GLMContextChanged).
	self assert: (GLMLogger instance announcements at: 5) presentation isNil.
	self assert: (GLMLogger instance announcements at: 5) property equals: #entity.
	self assert: (GLMLogger instance announcements at: 5) value equals: 42.	"6. Due to the context change of 5, the innermost presentation now matches."
	self assert: ((GLMLogger instance announcements at: 6) isKindOf: GLMMatchingPresentationsChanged).
	self assert: (GLMLogger instance announcements at: 6) pane == browser2 panes first.
	self assert: (GLMLogger instance announcements at: 6) oldMatchingPresentations isEmpty.
	self assert: (GLMLogger instance announcements at: 6) matchingPresentations size equals: 1.
	self assert: (GLMLogger instance announcements at: 6) matchingPresentations first isNil.	"7. Due to the context change of 3, the inner browser now matches."
	self assert: ((GLMLogger instance announcements at: 7) isKindOf: GLMMatchingPresentationsChanged).
	self assert: (GLMLogger instance announcements at: 7) pane == browser1 panes first.
	self assert: (GLMLogger instance announcements at: 7) oldMatchingPresentations isEmpty.
	self assert: (GLMLogger instance announcements at: 7) matchingPresentations size equals: 1.
	self assert: (GLMLogger instance announcements at: 7) matchingPresentations first == browser2.	"8. Due to the context change of 1, the outer browser now matches."
	self assert: ((GLMLogger instance announcements at: 8) isKindOf: GLMMatchingPresentationsChanged).
	self assert: (GLMLogger instance announcements at: 8) pane == browser1 pane.
	self assert: (GLMLogger instance announcements at: 8) oldMatchingPresentations isEmpty.
	self assert: (GLMLogger instance announcements at: 8) matchingPresentations size equals: 1.
	self assert: (GLMLogger instance announcements at: 8) matchingPresentations first == browser1! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'TudorGirba 4/22/2012 23:08'!
testPropagationDuringCircularDependencies
	| browser announcements |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [:a | a list display: [:x | 1 to: x ] ].
	browser transmit from: #one; to: #two; andShow: [:a | a list display: [:x | 1 to: x ] ].
	browser transmit from: #two port: #toSelect; toOutsidePort: #toSelect.
	browser transmit fromOutsidePort: #toSelect; to: #one port: #selection.
	browser transmit fromOutsidePort: #toSelect; to: #two port: #selection.
	browser startOn: 100.
	((browser paneNamed: #one) port: #selection) value: 50.
	((browser paneNamed: #two) port: #toSelect) value: 42.
	self assert: ((browser paneNamed: #one) port: #selection) value equals: 42.
	self assert: ((browser paneNamed: #two) port: #selection) value equals: 42.
	announcements := GLMLogger instance announcements reverse reject: [:each | each isKindOf: GLMTransmissionTriggered ].
	self assert: (announcements first isKindOf: GLMMatchingPresentationsChanged).
	self assert: (announcements second isKindOf: GLMPresentationsChanged).
	self assert: (announcements third isKindOf: GLMContextChanged).
	self assert: (announcements third property = #toSelect).
	self assert: (announcements fourth isKindOf: GLMContextChanged).
	self assert: (announcements fourth property = #toSelect).
	self assert: (announcements fourth isKindOf: GLMContextChanged).
	self assert: (announcements fifth property = #selection).
	self assert: (announcements fifth value = 42).
	self assert: (announcements fifth presentation isKindOf: GLMListPresentation).
	self assert: (announcements fifth presentation pane name = #two).
	self assert: (announcements sixth property = #selection).
	self assert: (announcements sixth value = 42).
	self assert: (announcements sixth presentation isKindOf: GLMCompositePresentation).
	self assert: (announcements sixth presentation pane name = #two).
	! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimple
	GLMPresentation new announce: GLMContextChanged new.
	self assert: GLMLogger instance announcements size equals: 1! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimpleEmptyPane
	| pane |
	pane := GLMPane new.
	pane browser: GLMBrowser new.
	(pane port: #entity) value: 42.
	self assert: GLMLogger instance announcements size equals: 1.
	self assert: (GLMLogger instance announcements first isKindOf: GLMContextChanged)! !

!GLMAnnouncementPropagationTest methodsFor: 'tests' stamp: 'TudorGirba 10/8/2011 18:54'!
testSimplePropagation
	| browser |
	browser := GLMTabulator new.
	browser column: #pane1.
	(browser transmit)
		to: #pane1;
		andShow: [ :a | a text ].
	browser startOn: 42.
	self assert: GLMLogger instance announcements copy size equals: 8! !

TestCase subclass: #GLMAnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMAnnouncerTest methodsFor: 'running' stamp: 'tg 2/17/2010 23:20'!
setUp
	announcer := GLMAnnouncer new! !

!GLMAnnouncerTest methodsFor: 'tests' stamp: 'tg 2/17/2010 23:59'!
testNestedSuspendAllWhile
	| announcement |
	announcer
		subscribe: TestAnnouncement
		do: [ :ann | announcement := ann ].
	
	announcement := nil.
	announcer suspendAllWhile: [
		announcer suspendAllWhile: [ ].
		announcer announce: TestAnnouncement ].
	self assert: announcement isNil! !

!GLMAnnouncerTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSuspendAllWhile
	| announcement instance |
	announcer subscribe: TestAnnouncement do: [ :ann | announcement := ann ].
	announcement := nil.
	instance := announcer announce: TestAnnouncement.
	self assert: announcement equals: instance.
	announcement := nil.
	announcer suspendAllWhile: [ instance := announcer announce: TestAnnouncement ].
	self assert: announcement isNil! !

TestCase subclass: #GLMBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMBrowserTest methodsFor: 'tests' stamp: 'TudorGirba 4/22/2012 21:59'!
testAddPane
	| browser pane |
	browser := GLMBrowser new.
	self assert: browser panes isEmpty.
	pane := GLMPane new.
	browser addPane: pane.
	self assert: pane browser = browser! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'TudorGirba 4/22/2012 21:57'!
testAddTransmissions
	| browser transmission |
	browser := GLMBrowser new.
	self assert: browser transmissions isEmpty.
	transmission := GLMTransmission new.
	browser addTransmission: transmission.
	self assert: transmission browser = browser.! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'TudorGirba 8/19/2011 22:47'!
testCompositeInTheParentPane
	| browser |
	browser := GLMBrowser new.
	self assert: (browser pane presentations isKindOf: GLMCompositePresentation).
	self assert: browser pane presentations size equals: 1.
	self assert: browser pane presentations first equals: browser! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testHasStatusbar
	| browser |
	browser := GLMBrowser new.
	self deny: browser hasStatusbar.
	browser hasStatusbar: true.
	self assert: browser panes size equals: 1.
	self assert: browser panes first name equals: GLMBrowser defaultStatusbarPane.
	self assert: browser statusbarPane == browser panes first! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testStatusbarTransmissions
	| browser pane |
	browser := GLMBrowser new.
	browser addStatusbar.
	pane := GLMPane new.
	browser addPane: pane.
	self assert: browser transmissions size equals: 1.
	self assert: browser transmissions first origins size equals: 1.
	self assert: browser transmissions first origins first equals: (pane port: #status).
	self assert: browser transmissions first destination equals: (browser panes first port: #entity).
	self assert: (browser transmissions first presentations first isKindOf: GLMLabelPresentation)! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testStatusbarTransmissionsTriggered
	| browser pane |
	browser := GLMTabulator new.
	browser addStatusbar.
	self assert: browser statusbarPane notNil.
	self assert: browser statusbarPane ~= browser.
	pane := (GLMPane in: browser) name: #one.
	browser addPane: pane.
	self assert: browser transmissions size equals: 1.
	(pane port: #status) value: #test.
	self assert: browser statusbarPane ~= browser.
	self assert: (browser statusbarPane port: #entity) value equals: #test.
	self assert: browser statusbarPane presentations size equals: 1.
	self assert: (browser statusbarPane presentations first isKindOf: GLMLabelPresentation)! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'TudorGirba 4/22/2012 22:00'!
testTransmissionTriggeredAnnounced
	| browser announcements pane1 pane2 transmission |
	announcements := OrderedCollection new.
	browser := GLMBrowser new.
	pane1 := GLMPane new.
	pane2 := GLMPane new.
	browser addPane: pane1.
	browser addPane: pane2.
	transmission := GLMTransmission new.
	transmission addActiveOrigin: (pane1 port: #origin).
	transmission destination: (pane2 port: #destination).
	browser addTransmission: transmission.
	browser on: GLMTransmissionTriggered do: [:ann | 
		announcements add: ann ].
	self assert: announcements isEmpty.
	transmission transmit.
	self assert: announcements size = 1! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'EstebanLorenzano 2/13/2012 13:32'!
testUnregisterAnnouncements
	| announcer presentation browser pane |
	announcer := Announcer new.
	browser := GLMBrowser new.
	pane := GLMPane new.
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	browser addPane: pane.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	presentation registerAnnouncements.
	self assert: announcer numberOfSubscriptions equals: 1.
	browser unregisterFromAllAnnouncements.
	self assert: announcer numberOfSubscriptions equals: 0! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'EstebanLorenzano 2/13/2012 13:32'!
testUnregisterAnnouncementsWhenRemovingPane
	| announcer presentation browser pane |
	announcer := Announcer new.
	browser := GLMBrowser new.
	pane := GLMPane new.
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	browser addPane: pane.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	presentation registerAnnouncements.
	self assert: announcer numberOfSubscriptions equals: 1.
	browser removePane: pane.
	self assert: announcer numberOfSubscriptions equals: 0! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'EstebanLorenzano 2/13/2012 13:32'!
testUnregisterAnnouncementsWhenUpdatingPane
	| announcer browser |
	announcer := Announcer new.
	browser := GLMTabulator new.
	browser row: #one.
	(browser transmit)
		to: #one;
		andShow: [ :presenter | 
					(presenter list)
						updateOn: TestAnnouncement from: [ announcer ];
						display: [ :start | start to: 10 ] ].
	browser startOn: 1.
	browser panes first presentations first registerAnnouncements.
	browser unregisterFromAllAnnouncements.
	self assert: announcer numberOfSubscriptions equals: 0! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'EstebanLorenzano 2/13/2012 13:33'!
testUnregisterAnnouncementsWhenUpdatingPaneWithTwoAnnouncers
	| announcer browser announcer2 |
	announcer := Announcer new.
	announcer2 := Announcer new.
	browser := GLMTabulator new.
	browser row: #one.
	(browser transmit)
		to: #one;
		andShow: [ :presenter | 
					(presenter list)
						updateOn: TestAnnouncement
							fromAll: [ 
									{announcer.
									nil.
									announcer2} ];
						display: [ :start | start to: 10 ] ].
	browser startOn: 1.
	browser panes first presentations first registerAnnouncements.
	browser unregisterFromAllAnnouncements.
	self assert: announcer numberOfSubscriptions equals: 0.
	self assert: announcer2 numberOfSubscriptions equals: 0! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'TudorGirba 12/5/2011 12:26'!
testUpdateRecomputesMatchingPresentations
	| browser collection matchingPresentationsChangedAnnounced | 
	collection := GLMAnnouncingCollection new.
	collection add: 1.
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | 
		a list when: [:col | col isEmpty not ]].
	browser startOn: collection.
	matchingPresentationsChangedAnnounced := false.
	browser panes first on: GLMMatchingPresentationsChanged do: [:ann | 
		matchingPresentationsChangedAnnounced := true ].
	collection removeLast.
	browser update.
	self assert: matchingPresentationsChangedAnnounced! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'TudorGirba 5/21/2012 00:29'!
testWatcherCopy
	| browser pane transmission browserCopy |
	browser := GLMBrowser new.
	pane := GLMPane named: 'one'.
	browser addPane: pane.
	transmission := GLMTransmission new.
	browser addTransmission: transmission.
	transmission addActiveOrigin: (browser panes first port: #origin).
	transmission toWatcher.
	
	browserCopy := browser copy.
	self assert: browserCopy transmissions size = 1.
	self assert: (browserCopy panes first port: #origin) value = nil.
	self assert: (browserCopy watcherPane port: #entity) value = nil.
	(browserCopy panes first port: #origin) value: 42.
	 browserCopy transmissions first transmit.
	self assert: (browserCopy watcherPane port: #entity) value = 42! !

!GLMBrowserTest methodsFor: 'tests' stamp: 'TudorGirba 5/21/2012 00:21'!
testWatcherCreation
	| browser pane |
	browser := GLMBrowser new.
	self assert: browser watcherPane name = #'_watcher'.
	(browser watcherPane port: #entity) value: 42.
	self assert: (browser watcherPane port: #entity) value = 42! !

TestCase subclass: #GLMBundleTransmissionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:40'!
testCopy
	| transmission newTransmission | 
	transmission := GLMTransmission new. 
	transmission addActiveOrigin: ((GLMSimplePort new) name: #port1; value: 1). 
	transmission addPassiveOrigin: ((GLMSimplePort new) name: #port2; value: 2). 
	transmission addActiveOrigin: ((GLMSimplePort new) name: #port3; value: 3). 
	transmission addPassiveOrigin: ((GLMSimplePort new) name: #port4; value: 4). 
	transmission destination: (GLMSimplePort new name: #port5). 

	newTransmission := transmission copy.
	
	self assert: transmission originReferences first ~= newTransmission originReferences first.! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPorts
	"Tests that the origins are set up properly and that their order is retained."

	| transmission |
	transmission := GLMTransmission new.
	transmission
		addActiveOrigin:
			((GLMSimplePort new)
				name: #port1;
				value: 1).
	transmission
		addPassiveOrigin:
			((GLMSimplePort new)
				name: #port2;
				value: 2).
	transmission
		addActiveOrigin:
			((GLMSimplePort new)
				name: #port3;
				value: 3).
	transmission
		addPassiveOrigin:
			((GLMSimplePort new)
				name: #port4;
				value: 4).
	transmission destination: (GLMSimplePort new name: #port5).
	self assert: transmission originReferences size equals: 4.
	transmission originReferences do: [ :each | self assert: (each isKindOf: GLMOriginPortReference) ].
	self assert: (transmission originReferences at: 1) port name equals: #port1.
	self assert: (transmission originReferences at: 2) port name equals: #port2.
	self assert: (transmission originReferences at: 3) port name equals: #port3.
	self assert: (transmission originReferences at: 4) port name equals: #port4.
	self assert: transmission origins size equals: 4.
	transmission origins do: [ :each | self assert: (each isKindOf: GLMSimplePort) ].
	self assert: (transmission origins at: 1) name equals: #port1.
	self assert: (transmission origins at: 2) name equals: #port2.
	self assert: (transmission origins at: 3) name equals: #port3.
	self assert: (transmission origins at: 4) name equals: #port4.
	self assert: transmission activeOrigins size equals: 2.
	transmission activeOrigins do: [ :each | self assert: (each isKindOf: GLMSimplePort) ].
	self assert: (transmission activeOrigins at: 1) name equals: #port1.
	self assert: (transmission activeOrigins at: 2) name equals: #port3.
	self assert: transmission passiveOrigins size equals: 2.
	transmission passiveOrigins do: [ :each | self assert: (each isKindOf: GLMSimplePort) ].
	self assert: (transmission passiveOrigins at: 1) name equals: #port2.
	self assert: (transmission passiveOrigins at: 2) name equals: #port4.
	self assert: (transmission destination isKindOf: GLMSimplePort).
	self assert: transmission destination name equals: #port5! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentations
	"Tests that the presentations are set up correctly."

	| transmission presentation1 presentation2 presentation3 |
	transmission := GLMTransmission new ensureReplacePresentationsStrategy.
	transmission
		addActiveOrigin:
			((GLMSimplePort new)
				name: #port1;
				value: 1).
	transmission
		addPassiveOrigin:
			((GLMSimplePort new)
				name: #port2;
				value: 2).
	transmission destination: (GLMSimplePort new name: #port3).
	presentation1 := GLMPresentation new title: 'presentation1'.
	presentation2 := GLMPresentation new title: 'presentation2'.
	presentation3 := GLMPresentation new title: 'presentation3'.
	transmission transmissionStrategy addPresentation: presentation1.
	transmission transmissionStrategy addPresentation: presentation2.
	transmission transmissionStrategy addPresentation: presentation3.	"Test correct setup"
	self assert: transmission transmissionStrategy presentations size equals: 3.
	self assert: (transmission transmissionStrategy presentations at: 1) == presentation1.
	self assert: (transmission transmissionStrategy presentations at: 2) == presentation2.
	self assert: (transmission transmissionStrategy presentations at: 3) == presentation3! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testTransmitting
	"Tests that the origins are set up properly and that their order is retained."

	| transmission |
	transmission := GLMTransmission new.
	transmission
		addActiveOrigin:
			((GLMSimplePort new)
				name: #port1;
				value: 1).
	transmission destination: (GLMSimplePort new name: #port5).
	self assert: transmission value equals: 1.
	self assert: transmission destination value isNil.
	transmission transmit.
	self assert: transmission destination value equals: 1.
	transmission
		addPassiveOrigin:
			((GLMSimplePort new)
				name: #port2;
				value: 2).
	transmission
		addActiveOrigin:
			((GLMSimplePort new)
				name: #port3;
				value: 3).
	transmission
		addPassiveOrigin:
			((GLMSimplePort new)
				name: #port4;
				value: 4).
	self assert: transmission value equals: (GLMMultiValue withAll: #(1 2 3 4)).
	transmission transmit.
	self assert: transmission destination value equals: (GLMMultiValue withAll: #(1 2 3 4))! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/31/2010 01:40'!
testTriggerConditions 
	"Tests that the transmission is triggered only when the active origins change." 
	 
	| transmission port1 port2 | 
	transmission := GLMTransmission new. 
	port1 := GLMSimplePort new name: #port1. 
	port2 := GLMSimplePort new name: #port2. 
	transmission addActiveOrigin: port1. 
	transmission addPassiveOrigin: port2. 
	transmission destination: (GLMPort new name: #port3). 
	self assert: (transmission originatesAt: port1). 
	self assert: (transmission originatesAt: port2) not! !

!GLMBundleTransmissionTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:51'!
testTriggerConditionsWithParentPort 
	 
	| transmission presentation | 
	transmission := GLMTransmission new. 
	presentation := GLMPresentation new. 
	transmission 
		addActiveOrigin: 
			((GLMPresentationBoundPort new) 
				presentation: presentation; 
				name: #port1; 
				yourself). 
	self 
		assert: 
			(transmission 
				originatesAt: 
					((GLMPresentationBoundPort new) 
						presentation: presentation; 
						name: #port1; 
						yourself)). 
	self assert: (transmission originatesAt: (presentation pane port: #port1))! !

TestCase subclass: #GLMCompositePresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMCompositePresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAdd
	| composite |
	composite := GLMCompositePresentation new.
	composite add: GLMPresentation new.
	self assert: composite isEmpty not.
	self assert: composite presentations size equals: 1! !

!GLMCompositePresentationTest methodsFor: 'tests' stamp: 'TudorGirba 10/8/2011 16:38'!
testAddRaisesAnnouncement
	| composite announcementCount pane |
	composite := GLMCompositePresentation new.
	pane := composite pane.
	announcementCount := 0.
	composite entity: 42.
	pane on: GLMMatchingPresentationsChanged do: [:ann | 
		announcementCount := announcementCount + 1 ].
	composite add: GLMPresentation new.
	self assert: announcementCount equals: 1! !

!GLMCompositePresentationTest methodsFor: 'tests' stamp: 'TudorGirba 10/8/2011 16:39'!
testAddSetsCorrectPane
	| composite presentation |
	composite := GLMCompositePresentation new.
	presentation := GLMPresentation new.
	composite add: presentation.
	self assert: composite pane = presentation pane! !

!GLMCompositePresentationTest methodsFor: 'tests - composer' stamp: 'TudorGirba 10/8/2011 18:50'!
testCreateFinder

	| show |
	show := GLMCompositePresentation new.
	show finder with: [:b | b show: [:a | a text ] ].
	self assert: show size = 1.
	self assert: (show first isKindOf: GLMFinder).
	show startOn: 42.
	self assert: show first panes size = 1.
	self assert: (show first panes first port: #entity) value = 42! !

!GLMCompositePresentationTest methodsFor: 'tests - composer' stamp: 'TudorGirba 10/8/2011 18:52'!
testCreateTabulator

	| show |
	show := GLMCompositePresentation new.
	show tabulator with: [:b | b row: #one. b transmit to: #one; transformed: [:x | x + 1]; andShow: [:a | a text ] ].
	self assert: show size = 1.
	self assert: (show first isKindOf: GLMTabulator).
	show startOn: 41.
	self assert: show first panes size = 1.
	self assert: (show first panes first port: #entity) value = 42! !

!GLMCompositePresentationTest methodsFor: 'tests' stamp: 'tg 1/5/2010 15:17'!
testCreation
	| composite |
	composite := GLMCompositePresentation new.
	self assert: composite isEmpty! !

!GLMCompositePresentationTest methodsFor: 'tests' stamp: 'TudorGirba 10/8/2011 15:20'!
testDefaultPane
	| composite |
	composite := GLMCompositePresentation new.
	self assert: composite pane presentations = composite! !

!GLMCompositePresentationTest methodsFor: 'tests' stamp: 'tg 5/25/2010 14:34'!
testPane
	| pane composite presentation |
	pane := GLMPane new.
	composite := GLMCompositePresentation new.
	presentation := GLMPresentation new.
	composite add: presentation.
	composite pane: pane.
	self assert: composite pane == pane.
	self assert: composite first pane == pane! !

!GLMCompositePresentationTest methodsFor: 'tests' stamp: 'TudorGirba 10/30/2011 09:42'!
testStartingPreservesItself
	| composite finder |
	composite := GLMCompositePresentation new.
	finder := composite finder.
	composite startOn: 42.
	self assert: composite pane presentations = composite.
	self assert: composite first == finder.! !

TestCase subclass: #GLMDashboardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMDashboardTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPanes
	| layout |
	layout := GLMDashboard new.
	layout addPaneNamed: #one.
	layout addPaneNamed: #two.
	layout addPaneNamed: #three.
	self assert: layout panes size equals: 3.
	#(#one #two #three) do: [ :aSymbol | self assert: (layout panes anySatisfy: [ :aGLMPane | aGLMPane name = aSymbol ]) ]! !

!GLMDashboardTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPanesAndExtents
	| layout |
	layout := GLMDashboard new.
	layout rigidStrategy.
	layout addPaneNamed: #one extent: 20 @ 45.
	layout addPaneNamed: #two extent: 50 @ 10.
	layout addPaneNamed: #three extent: 20 @ 40.
	layout addPaneNamed: #four.
	self assert: layout panes size equals: 4.
	self assert: (layout extentOfPaneNamed: #one) equals: 20 @ 45.
	self assert: (layout extentOfPaneNamed: #two) equals: 50 @ 10.
	self assert: (layout extentOfPaneNamed: #three) equals: 20 @ 40	"self assert: (layout extentOfPaneNamed: #four) =  layout defaultPaneExtent. "! !

TestCase subclass: #GLMDyanmicPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMDyanmicPresentationTest methodsFor: 'tests' stamp: 'TudorGirba 7/14/2011 10:44'!
testCachedPresentation
	| dynamic currentPresentation |
	dynamic := GLMDynamicPresentation new.
	dynamic entity: 42.
	dynamic transformation: [ :entity | GLMTextPresentation new ].
	currentPresentation := dynamic currentPresentation.

	self assert: dynamic cachedPresentation == currentPresentation! !

!GLMDyanmicPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testDefaultPresentation
	| dynamic |
	dynamic := GLMDynamicPresentation new.
	dynamic entity: 42.
	dynamic transformation: [ :entity | GLMTextPresentation new ].
	self assert: dynamic currentPresentation presentations size equals: 1.
	self assert: (dynamic currentPresentation presentations first isKindOf: GLMTextPresentation).
	self assert: dynamic currentPresentation pane == dynamic pane! !

!GLMDyanmicPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentationTransformation
	| dynamic |
	dynamic := GLMDynamicPresentation new.
	dynamic entity: 42.
	dynamic presentationTransformation: [ :some :entity | (1 to: entity) do: [ :each | some text title: each asString ] ].
	self assert: dynamic currentPresentation presentations size equals: 42.
	self assert: dynamic currentPresentation pane == dynamic pane! !

TestCase subclass: #GLMExpanderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMExpanderTest methodsFor: 'tests' stamp: 'DamienCassou 7/2/2011 14:33'!
testAllowNilConditionWhenEmbedded
	| expander tabulator |
	expander := GLMExpander new.
	expander allowNil.
	expander display: [ :x :y | x + y ].	"should lead to an error because nil is allowed in the block"
	expander show: [ :a | a text display: [ :x :y | x asString , y asString ] ].
	tabulator := GLMTabulator new.
	tabulator
		column: #one;
		column: #two.
	(tabulator transmit)
		to: #two;
		fromOutsidePort: #entity;
		from: #one port: #nilPort;
		andShow: [ :a | a custom: expander ].
	self should: [ tabulator startOn: 1 ] raise: Error! !

!GLMExpanderTest methodsFor: 'tests' stamp: 'DamienCassou 7/2/2011 14:33'!
testConditionWhenEmbedded
	| expander tabulator |
	expander := GLMExpander new.
	expander display: [ :x :y | x + y ].
	expander show: [ :a | a text display: [ :x :y | x asString , y asString ] ].
	tabulator := GLMTabulator new.
	tabulator
		column: #one;
		column: #two.
	(tabulator transmit)
		to: #two;
		fromOutsidePort: #entity;
		from: #one port: #nilPort;
		andShow: [ :a | a custom: expander ].
	self shouldnt: [ tabulator startOn: 1 ] raise: Error! !

!GLMExpanderTest methodsFor: 'tests' stamp: 'tg 5/1/2010 12:29'!
testCreation
	self assert: GLMExpander new panes isEmpty! !

!GLMExpanderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentations
	| expander |
	expander := GLMExpander new.
	expander show: [ :a | a text ].
	expander startOn: #(#a #b #c).
	self assert: expander panes size equals: 3.
	self assert: expander panes first presentations entity value equals: #a.
	self assert: expander panes first presentations size equals: 1.
	self assert: (expander panes first presentations first isKindOf: GLMTextPresentation)! !

!GLMExpanderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimple
	| expander |
	expander := GLMExpander new.
	expander startOn: #(#a #b #c).
	self assert: expander panes size equals: 3.
	self assert: (expander panes first port: #entity) value equals: #a! !

TestCase subclass: #GLMExplicitBrowserCopyTest
	instanceVariableNames: 'browser copiedBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMExplicitBrowserCopyTest methodsFor: 'tests' stamp: 'DamienCassou 7/9/2011 20:19'!
setUp
	| pane1 pane2 transmission1 transmission2 | 
	browser := GLMExplicitBrowser new. 
	
	pane1 := browser addNewPane name: 'pane1'. 
	pane2 := browser addNewPane name: 'pane2'. 
	transmission1 := GLMTransmission new
		addActiveOrigin: (pane2 port: #selection); 
		destination: (GLMPresentationBoundPort new name: #selection; presentation: browser; yourself); 
		yourself.  
	browser addTransmission: transmission1. 
	transmission2 := GLMTransmission new 
		ensureReplacePresentationsStrategy;
		addActiveOrigin: (pane1 port: #selection); 
		destination: (pane2 port: #entity); 
		addPresentation: (GLMPresentation new title: 'presentation1');
		yourself.  
	browser addTransmission: transmission2. 
	copiedBrowser := browser copy! !

!GLMExplicitBrowserCopyTest methodsFor: 'tests' stamp: 'tg 8/22/2010 15:45'!
testEquality
	self assert: (copiedBrowser = browser) not! !

!GLMExplicitBrowserCopyTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPanes
	self assert: copiedBrowser panes size equals: 2.
	self assert: copiedBrowser panes first ~~ browser panes first.
	self assert: copiedBrowser panes last ~~ browser panes last.
	self assert: copiedBrowser panes first browser == copiedBrowser.
	self assert: copiedBrowser panes last browser == copiedBrowser.
	self assert: copiedBrowser panes first ports size equals: 1.
	self assert: copiedBrowser panes first ports first name equals: #selection.
	self assert: copiedBrowser panes first ports first pane == copiedBrowser panes first.
	self assert: copiedBrowser panes last ports size equals: 2.
	self assert: copiedBrowser panes last ports first name equals: #selection.
	self assert: copiedBrowser panes last ports last name equals: #entity! !

!GLMExplicitBrowserCopyTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testTrasmissions
	self assert: copiedBrowser transmissions size equals: 2.
	self assert: copiedBrowser transmissions first ~~ browser transmissions first.
	self assert: copiedBrowser transmissions last ~~ browser transmissions last.
	self assert: (copiedBrowser transmissions first destination pane browser isKindOf: GLMNoBrowser).
	self assert: copiedBrowser transmissions last destination pane browser == copiedBrowser.
	self assert: copiedBrowser transmissions first origins first pane browser == copiedBrowser.
	self assert: copiedBrowser transmissions last origins first pane browser == copiedBrowser! !

TestCase subclass: #GLMExplicitBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'tg 1/14/2010 16:10'!
testAddTransmissionReturn
	| transmission |
	transmission := GLMTransmission new.
	self assert: (GLMExplicitBrowser new addTransmission: transmission) == transmission! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testJumpstartTransmission
	| browser presentation |
	browser := GLMExplicitBrowser new.
	presentation := GLMPresentation new.
	browser addNewPane.
	browser
		addTransmission:
			((GLMTransmission new)
				ensureReplacePresentationsStrategy;
				addActiveOrigin: (browser pane port: #entity);
				destination: (browser panes first port: #entity);
				addPresentation: presentation;
				yourself).
	self assert: (browser panes first port: #entity) value isNil.
	self assert: browser panes first presentations isEmpty.
	(browser pane port: #entity) value: #foo.
	self assert: (browser panes first port: #entity) value equals: #foo.
	self assert: browser panes first presentations size equals: 1.
	self assert: browser panes first presentations first rootPrototype equals: presentation! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentationBoundPort
	| browser outerPort1 outerPort2 transmission1 transmission2 |
	browser := GLMExplicitBrowser new.
	browser addNewPane.
	GLMTestPane new addPresentation: browser.
	outerPort1 := (GLMPresentationBoundPort new)
		presentation: browser;
		name: #outerPort1;
		yourself.
	outerPort2 := (GLMPresentationBoundPort new)
		presentation: browser;
		name: #outerPort2;
		yourself.	"Capturing"
	browser
		addTransmission:
			(transmission1 := (GLMMockSimpleTransmission new)
				addActiveOrigin: outerPort1;
				destination: (browser panes first port: #innerPort1);
				yourself).	"Publishing"
	browser
		addTransmission:
			((transmission2 := GLMMockSimpleTransmission new)
				addActiveOrigin: (browser panes first port: #innerPort2);
				destination: outerPort2;
				yourself).
	(browser pane port: #outerPort1) value: 42.
	self assert: (browser panes first port: #innerPort1) value equals: 42.
	self assert: transmission1 wasTransmited.
	self deny: transmission2 wasTransmited.	"self assert: (browser pane port: #outerPort1) seenTransmissions size = 0. "	"self 
		assert: 
			((browser pane port: #outerPort1) seenTransmissions first isKindOf: 
					GLMSimpleTransmission). 
	self 
		assert: 
			((browser pane port: #outerPort1) seenTransmissions first origin isKindOf: 
					GLMSimplePort). 
	self 
		assert: 
			(browser pane port: #outerPort1) seenTransmissions first destination 
				== (browser pane port: #outerPort1). "	"self 
		assert: 
			(browser panes first port: #innerPort1) seenTransmissions size = 1. 
	self 
		assert: 
			(browser panes first port: #innerPort1) seenTransmissions first 
				== browser transmissions first. "
	(browser panes first port: #innerPort2) value: 43.
	self assert: (browser pane port: #outerPort2) value equals: 43	"self 
		assert: 
			(browser panes first port: #innerPort2) seenTransmissions size = 0. "	"self 
		assert: 
			((browser panes first port: #innerPort2) seenTransmissions first isKindOf: 
					GLMSimpleTransmission). 
	self 
		assert: 
			((browser panes first port: #innerPort2) seenTransmissions first origin 
				isKindOf: GLMSimplePort). 
	self 
		assert: 
			(browser panes first port: #innerPort2) seenTransmissions first destination 
				== (browser panes first port: #innerPort2). "	"self assert: (browser pane port: #outerPort2) seenTransmissions size = 1. 
	self 
		assert: 
			(browser pane port: #outerPort2) seenTransmissions first 
				== browser transmissions last"! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSetup
	| browser pane1 pane2 transmission |
	browser := GLMExplicitBrowser new.
	pane1 := browser addNewPane.
	pane2 := browser addNewPane.
	transmission := (GLMTransmission new)
		addActiveOrigin: (pane1 port: #selection);
		destination: (pane2 port: #entity);
		yourself.
	browser addTransmission: transmission.
	self assert: browser panes size equals: 2.
	self assert: browser transmissions size equals: 1.
	self assert: browser panes first == pane1.
	self assert: browser panes last == pane2.
	self assert: pane1 browser == browser.
	self assert: pane2 browser == browser.
	self assert: browser transmissions first == transmission! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimpleTransmission
	| browser pane1 pane2 presentation1 presentation2 transmission announcement |
	browser := GLMExplicitBrowser new.
	presentation1 := GLMPresentation new.
	presentation2 := GLMPresentation new.
	pane1 := browser addNewPane.
	pane2 := browser addNewPane.
	pane1 addPresentation: presentation1.
	pane2 addPresentation: presentation2.
	transmission := (GLMMockSimpleTransmission new)
		addActiveOrigin: (pane1 port: #selection);
		destination: (pane2 port: #entity);
		yourself.
	browser addTransmission: transmission.
	announcement := nil.
	presentation2 when: GLMContextChanged do: [ :ann | announcement := ann ].
	presentation1 selection: 'foo'.
	self assert: transmission wasTransmited.	"self assert: (pane1 port: #selection) seenTransmissions size = 0. 
	self assert: (pane2 port: #entity) seenTransmissions size = 1."	"self 
		assert: (pane1 port: #selection) seenTransmissions first ~~ transmission. "	"self assert: (pane2 port: #entity) seenTransmissions first == transmission. "
	self assert: (pane1 port: #selection) value equals: 'foo'.
	self assert: (pane2 port: #entity) value equals: 'foo'.
	self assert: announcement notNil! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testTransmissionBundle
	| browser pane1 pane2 pane3 presentation1 presentation2 transmission |
	browser := GLMExplicitBrowser new.
	presentation1 := GLMPresentation new.
	presentation2 := GLMPresentation new.
	pane1 := GLMTestPane new.
	pane2 := GLMTestPane new.
	pane3 := GLMTestPane new.
	pane1 addPresentation: GLMPresentation new.
	pane2 addPresentation: GLMPresentation new.
	pane3 addPresentation: presentation1.
	transmission := (GLMTransmission new)
		ensureReplacePresentationsStrategy;
		addActiveOrigin: (pane1 port: #selection);
		addPassiveOrigin: (pane2 port: #selection);
		destination: (pane3 port: #entity);
		addPresentation: presentation2;
		yourself.
	browser addPane: pane1.
	browser addPane: pane2.
	browser addPane: pane3.
	browser addTransmission: transmission.
	self assert: pane3 presentations size equals: 1.
	self assert: pane3 presentations first == presentation1.
	pane2 presentations first selection: #foo.
	self assert: (pane2 port: #selection) seenTransmissions size equals: 1.
	self assert: (pane3 port: #entity) seenTransmissions size equals: 0.
	pane1 presentations first selection: #bar.
	self assert: (pane1 port: #selection) seenTransmissions size equals: 1.
	self assert: (pane3 port: #entity) seenTransmissions size equals: 1.
	self assert: (pane3 port: #entity) seenTransmissions last == transmission.
	self assert: (pane3 port: #entity) value equals: (GLMMultiValue withAll: #(#bar #foo)).
	self assert: pane3 presentations size equals: 1.
	self assert: pane3 presentations first rootPrototype equals: presentation2! !

!GLMExplicitBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testTriggeringConditions
	| browser pane1 pane2 transmission |
	browser := GLMExplicitBrowser new.
	browser pane: GLMTestPane new.
	pane1 := GLMTestPane new.
	pane2 := GLMTestPane new.
	transmission := (GLMTransmission new)
		addActiveOrigin: (pane1 port: #selection);
		destination: (pane2 port: #entity);
		yourself.
	browser addPane: pane1.
	browser addPane: pane2.
	browser addTransmission: transmission.
	self assert: (pane1 port: #selection) seenTransmissions isEmpty.
	self assert: (pane2 port: #entity) seenTransmissions isEmpty.
	(pane1 port: #selection) value: 12.
	self assert: (pane1 port: #selection) seenTransmissions size equals: 0.	"self 
		assert: 
			((pane1 port: #selection) seenTransmissions first isKindOf: 
					GLMSimpleTransmission). "
	self assert: (pane2 port: #entity) seenTransmissions size equals: 1.
	self assert: (pane2 port: #entity) seenTransmissions first == transmission.	"Setting the same value should re-publish but not trigger inner transmissions."
	(pane1 port: #selection) value: 12.
	self assert: (pane1 port: #selection) seenTransmissions size equals: 0.	"self 
		assert: 
			((pane1 port: #selection) seenTransmissions first isKindOf: 
					GLMSimpleTransmission). "	"self 
		assert: 
			((pane1 port: #selection) seenTransmissions last isKindOf: 
					GLMSimpleTransmission). "
	self assert: (pane2 port: #entity) seenTransmissions size equals: 1.
	self assert: (pane2 port: #entity) seenTransmissions first == transmission! !

TestCase subclass: #GLMExtensionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMExtensionsTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testGlamourValue
	"Block closure"

	self assert: ([ #foo ] glamourValue: #(1 2)) equals: #foo.
	self assert: ([ :first | Array with: first ] glamourValue: #(1 2)) equals: #(#(1 2)).
	self assert: ([ :first :second | Array with: first with: second ] glamourValue: #(1 2)) equals: #(#(1 2) nil).
	self
		assert: ([ :first :second | Array with: first with: second ] glamourValue: (GLMMultiValue with: 1 with: 2))
		equals: #(1 2).	"Symbol"
	self assert: (#yourself glamourValueWithArgs: #(1 2)) equals: 1.
	self assert: (#yourself glamourValueWithArgs: #()) equals: nil	"self assert: (#yourself glamourValue: (MultiValue with: 1 with: 2)) = 1."! !

!GLMExtensionsTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testGlamourValueWithArgs
	"Block closure"

	self assert: ([ #foo ] glamourValueWithArgs: #(1 2)) equals: #foo.
	self assert: ([ :first | Array with: first ] glamourValueWithArgs: #(1 2)) equals: #(1).
	self assert: ([ :first :second | Array with: first with: second ] glamourValueWithArgs: #(1 2)) equals: #(1 2).
	self
		assert: ([ :first :second :third | Array with: first with: second with: third ] glamourValueWithArgs: #(1 2))
		equals: #(1 2 nil).	"Symbol"
	self assert: (#yourself glamourValueWithArgs: #(1 2)) equals: 1.
	self assert: (#yourself glamourValueWithArgs: #()) equals: nil! !

TestCase subclass: #GLMFinderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMFinderTest methodsFor: 'tests' stamp: 'tg 3/31/2010 19:44'!
testEmptyPanes
	| browser | 
	browser := GLMFinder new. 
	self assert: browser panes isEmpty. 
	self assert: browser transmissions isEmpty.! !

!GLMFinderTest methodsFor: 'tests' stamp: 'TudorGirba 7/21/2011 12:12'!
testExplicitTransmission
	| finder |
	finder := GLMFinder new.
	finder transmit fromOutsidePort: #entity; toOutsidePort: #selection.
	finder startOn: 42.
	self assert: (finder pane port: #selection) value equals: 42! !

!GLMFinderTest methodsFor: 'tests' stamp: 'TudorGirba 7/21/2011 13:46'!
testExplicitTransmissionComplex
	"this tests a possible bug in the context copying that might prevent the explicit outside transmission"

	| finder browser |
	finder := GLMFinder new.
	finder transmit fromOutsidePort: #entity; toOutsidePort: #something.

	browser := GLMTabulator new.
	browser row: #explorer; row: #details.
	browser transmit to: #explorer; andShow: [:a | a custom: finder].
	browser transmit from: #explorer port: #something; to: #details; andShow: [:a | a text ].
	browser startOn: 42.

	self assert: (browser panes first port: #something) value equals: 42! !

!GLMFinderTest methodsFor: 'tests' stamp: 'TudorGirba 1/26/2011 10:58'!
testFixedSize
	| browser | 
	browser := GLMFinder new. 
	self assert: browser hasFixedSizePanes.
	browser hasFixedSizePanes: false.
	self assert: browser hasFixedSizePanes not	! !

!GLMFinderTest methodsFor: 'tests' stamp: 'TudorGirba 12/5/2011 14:18'!
testLastActivePresentation
	| browser | 
	browser := GLMFinder new. 
	browser show: [:a | a list title: 'a'. a text title: 'b'. a table title: 'c' ].
	browser startOn: 1.
	self assert: browser lastActivePresentation isNil.

	(browser panes first port: #selection) value: 2.
	self assert: browser lastActivePresentation isNil.
	browser panes last lastActivePresentation: browser panes last presentations last.
	self assert: browser lastActivePresentation = browser panes last presentations last.

	(browser panes first port: #selection) value: 3.
	self assert: (browser panes last lastActivePresentation title = 'c')! !

!GLMFinderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneAddedAnnouncement
	| browser count |
	count := 0.
	browser := GLMFinder new.
	browser on: GLMPaneAdded do: [ :ann | count := count + 1 ].
	browser startOn: #a.
	self assert: count equals: 1.
	(browser panes first port: #selection) value: #b.
	self assert: count equals: 2! !

!GLMFinderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneCreation
	| browser |
	browser := GLMFinder new.
	browser addPresentation: (GLMPresentation new title: 'presentation1').
	self assert: browser panes isEmpty.	"Outer entity changed."
	(browser pane port: #entity) value: #value1.
	self assert: browser panes size equals: 1.
	self assert: browser panes first browser == browser.
	self assert: (browser panes first port: #entity) value equals: #value1.
	self assert: browser panes first presentations size equals: 1.
	self assert: browser panes first presentations first title equals: 'presentation1'.
	self assert: browser panes first presentations first ~~ browser presentations first.	"First pane selection changed."
	(browser panes first port: #selection) value: #value2.
	self assert: browser panes size equals: 2.
	self assert: browser panes last browser == browser.
	self assert: (browser panes last port: #entity) value equals: #value2.
	self assert: browser panes last presentations first title equals: 'presentation1'.
	self assert: browser panes last presentations first ~~ browser presentations first.
	self assert: browser panes last presentations first ~~ browser panes first presentations first.	"Second pane selection changed."
	(browser panes last port: #selection) value: #value3.
	self assert: browser panes size equals: 3.
	self assert: browser panes last browser == browser.
	self assert: (browser panes last port: #entity) value equals: #value3.	"First pane selection changed again."
	(browser panes first port: #selection) value: #value4.
	self assert: browser panes size equals: 2.
	self assert: browser panes last browser == browser.
	self assert: (browser panes last port: #entity) value equals: #value4.	"Outer entity changed again."
	(browser pane port: #entity) value: #value5.
	self assert: browser panes size equals: 1.
	self assert: browser panes last browser == browser.
	self assert: (browser panes last port: #entity) value equals: #value5! !

!GLMFinderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneName
	| browser |
	browser := GLMFinder new.
	browser addPresentation: (GLMPresentation new title: 'presentation1').
	(browser pane port: #entity) value: #value1.
	self assert: browser panes first name equals: '1'.
	(browser panes first port: #selection) value: #value2.
	self assert: browser panes last name equals: '2'! !

!GLMFinderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneRemovedAnnouncement
	| browser count |
	count := 0.
	browser := GLMFinder new.
	browser on: GLMPaneRemoved do: [ :ann | count := count + 1 ].
	browser startOn: #a.
	self assert: count equals: 0.
	(browser panes first port: #selection) value: #b.
	self assert: count equals: 0.
	(browser panes second port: #selection) value: #c.
	self assert: count equals: 0.
	(browser panes first port: #selection) value: #d.
	self assert: count equals: 1! !

!GLMFinderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPaneReplacedAnnouncement
	| browser count |
	count := 0.
	browser := GLMFinder new.
	browser on: GLMPaneReplaced do: [ :ann | count := count + 1 ].
	browser startOn: #a.
	self assert: count equals: 0.
	(browser panes first port: #selection) value: #b.
	self assert: count equals: 0.
	(browser panes second port: #selection) value: #c.
	self assert: count equals: 0.
	(browser panes first port: #selection) value: #d.
	self assert: count equals: 1.
	browser entity: #e.
	self assert: count equals: 2! !

!GLMFinderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPanesHaveDifferentRegistries
	| browser |
	browser := GLMFinder new.
	browser addPresentation: (GLMPresentation new title: 'presentation1').
	self assert: browser panes isEmpty.	"Outer entity changed."
	(browser pane port: #entity) value: #value1.
	self assert: browser panes size equals: 1.
	(browser panes first port: #selection) value: #value2.
	self assert: browser panes size equals: 2.
	self deny: (browser panes first instVarNamed: 'registry') == (browser panes second instVarNamed: 'registry')! !

!GLMFinderTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPortPublishing
	| browser |
	browser := GLMFinder new.
	(browser pane port: #entity) value: #value1.
	self assert: browser panes size equals: 1.
	self assert: browser pane ports size equals: 1.
	self assert: (browser pane port: #entity) value equals: #value1.
	(browser panes first port: #selection) value: #value2.
	self assert: browser panes size equals: 2.
	self assert: browser pane ports size equals: 2.
	self assert: (browser pane port: #entity) value equals: #value1.
	self assert: (browser pane port: #selection) value equals: #value2.
	(browser panes last port: #selection) value: #value3.
	self assert: browser panes size equals: 3.
	self assert: browser pane ports size equals: 2.
	self assert: (browser pane port: #entity) value equals: #value1.
	self assert: (browser pane port: #selection) value equals: #value3.
	(browser panes first port: #hover) value: #value4.
	self assert: browser panes size equals: 3.
	self assert: browser pane ports size equals: 3.
	self assert: (browser pane port: #entity) value equals: #value1.
	self assert: (browser pane port: #selection) value equals: #value3.
	self assert: (browser pane port: #hover) value equals: #value4! !

!GLMFinderTest methodsFor: 'tests' stamp: 'EstebanLorenzano 2/13/2012 13:38'!
testUnregisterAnnouncementsWhenRemovingPane
	| announcer browser presentation actualFirstPresentation actualLastPresentation |
	announcer := GLMAnnouncer new.
	browser := GLMFinder new.
	presentation := GLMPresentation new.
	presentation title: [ :entity | entity ].
	browser addPresentation: presentation.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	browser entity: #value1.
	actualFirstPresentation := browser panes first presentations first.
	actualFirstPresentation registerAnnouncements.
	self assert: announcer numberOfSubscriptions equals: 1.
	self assert: announcer glmSubscriptions anyOne announcementClass equals: TestAnnouncement.
	self assert: announcer glmSubscriptions anyOne subscriber presentation equals: actualFirstPresentation.
	self assert: announcer glmSubscriptions anyOne subscriber presentation == actualFirstPresentation.
	(browser panes first port: #selection) value: #value2.
	browser panes last presentations first registerAnnouncements.
	actualLastPresentation := browser panes last presentations first.
	self assert: announcer numberOfSubscriptions equals: 2.
	self
		assert: (announcer glmSubscriptions allSatisfy: [ :each | each announcementClass = TestAnnouncement ]).
	self
		assert:
			(announcer glmSubscriptions anySatisfy: [ :each | each subscriber presentation = actualFirstPresentation ]).
	self
		assert:
			(announcer glmSubscriptions
				anySatisfy: [ :each | each subscriber presentation == actualFirstPresentation ]).
	(browser panes first port: #selection) value: #value3.
	actualLastPresentation := browser panes last presentations first.	"because we removed the other pane"
	self assert: announcer numberOfSubscriptions equals: 1.
	self assert: announcer glmSubscriptions anyOne announcementClass equals: TestAnnouncement.
	self assert: announcer glmSubscriptions anyOne subscriber presentation equals: actualFirstPresentation.
	self assert: announcer glmSubscriptions anyOne subscriber presentation == actualFirstPresentation! !

!GLMFinderTest methodsFor: 'tests' stamp: 'DamienCassou 7/2/2011 22:01'!
testValidSubscriptionsInComplexBrowser
	| browser navigator tabulator1 tabulator2 pane1 pane2 content1 content2 details1 details2|
	
	navigator := GLMTabulator new.
	navigator row: #content; row: #details.
	navigator transmit to: #content; andShow: [:a | a list display: #allSuperclasses].
	navigator transmit from: #content; to: #details; andShow: [ :a | a text].
	navigator transmit from: #content; toOutsidePort: #selection.
	 
	browser := GLMFinder new. 
	browser show: [:a | a custom: navigator].
	self assert: browser panes isEmpty.
	(browser pane port: #entity) value: String. 
	self assert: browser panes size equals: 1. 
	pane1 := browser panes first.
	tabulator1 := pane1 presentations first.
	content1 := tabulator1 panes first.
	self assert: content1 presentations first displayValue size equals: 5. "5 superclasses of String".
	(content1 port: #selection) value: Collection. "Assumes Collection is a superclass of String" 
	self assert: browser panes size equals: 2. 
	pane2 := browser panes second.
	tabulator2 := pane2 presentations first.
	content2 := tabulator2 panes first.
	self assert: content1 presentations first displayValue size equals: 5. "5 superclasses of String".
	self assert: content2 presentations first displayValue size equals: 2. "2 superclasses of Collection".
	details1 := tabulator1 panes second.
	self assert: details1 presentations first displayValue equals: Collection.
	(content2 port: #selection) value: Object. "Assumes Object is a superclass of Collection"
	self assert: details1 presentations first displayValue equals: Collection.
	details2 := tabulator2 panes second.
	self assert: details2 presentations first displayValue equals: Object.
	self assert: content1 presentations first displayValue size equals: 5. "5 superclasses of String".
	self assert: content2 presentations first displayValue size equals: 2. "2 superclasses of Collection".! !

TestCase subclass: #GLMFlexiblePresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMFlexiblePresentationTest methodsFor: 'tests' stamp: 'tg 11/16/2009 15:11'!
testDefault
	| browser |
	browser := GLMTabulator new.
	browser startOn: #(1 2 3).
	self assert: (browser panes first presentations first isKindOf: GLMFlexiblePresentation).
	browser startOn: 1.
	self assert: (browser panes first presentations first isKindOf: GLMFlexiblePresentation).! !

!GLMFlexiblePresentationTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:22'!
testDynamic
	| browser childBrowser |
	childBrowser := GLMFinder new.
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a |
		a custom: (GLMDynamicPresentation new display: [childBrowser]) ].
	browser startOn: 42.
	self assert: browser panes first presentations first currentPresentation first == childBrowser.
	self assert: childBrowser pane == browser panes first ! !

TestCase subclass: #GLMFormattedPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMFormattedPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testFormat
	| presentation |
	presentation := GLMFormatedPresentation new.
	presentation format: [ :c | c ].
	self assert: (presentation formatedDisplayValueOf: 1) equals: 1.
	presentation entity: 41.
	presentation format: [ :a :c | a + c ].
	self assert: (presentation formatedDisplayValueOf: 1) equals: 42.
	presentation entity: (GLMMultiValue with: 20 with: 21).
	presentation format: [ :a :b :c | a + b + c ].
	self assert: (presentation formatedDisplayValueOf: 1) equals: 42! !

TestCase subclass: #GLMHelperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMHelperTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAsGlamorousMultiValue
	self assert: (GLMMultiValue with: #(1 2 3)) equals: #(1 2 3) asGlamorousMultiValue.
	self
		assert: 1 asGlamorousMultiValue , 2 asGlamorousMultiValue , 3 asGlamorousMultiValue
		equals: (GLMMultiValue withAll: #(1 2 3))! !

!GLMHelperTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testGlamourValue
	self assert: ([ :a | a + 2 ] glamourValue: 40) equals: 42.
	self assert: ([ :a | a + 2 ] glamourValue: 40 asGlamorousMultiValue) equals: 42.
	self assert: ([ 42 ] glamourValue: 40 asGlamorousMultiValue) equals: 42.
	self assert: ([ :a | a first + a last ] glamourValue: #(40 2)) equals: 42.
	self assert: ([ :a :b | a + b ] glamourValue: (GLMMultiValue withAll: #(40 2))) equals: 42.
	self assert: ([ :a | a + 2 ] glamourValue: (GLMMultiValue withAll: #(40 2))) equals: 42.
	self assert: ([ 42 ] glamourValue: (GLMMultiValue withAll: #(40 2))) equals: 42! !

TestCase subclass: #GLMListPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMListPresentationTest methodsFor: 'tests' stamp: 'tg 9/20/2009 15:19'!
testChildren
	| tree |
	tree := GLMTreePresentation new.
	tree transformation: [:aNumber | (1 to: aNumber ) collect: #printString ].
	tree children: [:each | self assert: (each isKindOf: String)  ].
	tree entity: 42.! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCustomValidation
	| pane presentation |
	pane := GLMPane named: 'test'.
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	presentation customValidation: [ :object :aport :entity | aport ~= #selection or: [ object = (entity last + 40) ] ].
	presentation entity: (OrderedCollection with: 1 with: 2).
	self assert: presentation entity last equals: 2.
	self assert: (presentation validate: 42 on: (pane port: #selection))! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 5/8/2011 19:11'!
testSorted
	| presentation | 
	presentation := GLMListPresentation new. 
	presentation entity: #(#foo #bar #blurp).
	self assert: presentation displayValue equals: #(#foo #bar #blurp).
	presentation sorted. 
	self assert: presentation displayValue equals: #(#bar #blurp #foo).
	presentation sorted: [:a :b | a size < b size].  
	self assert: presentation displayValue equals: #(#bar #foo #blurp).! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testToSend
	| list |
	list := GLMListPresentation new.
	list selectionTransformation: [ :x | x + 1 ].
	list entity: (1 to: 100).
	list selection: 41.
	self assert: list selection equals: 42! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:50'!
testValidateOn
	| pane presentation |
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation shouldValidate: true.
	presentation entity: ($a to: $d).
	self deny: (presentation validate: (Array with: $a) on: (pane port: #selection)).
	self deny: (presentation validate: (Array with: $a with: $b) on: (pane port: #selection)).
	self assert: (presentation validate: $a on: (pane port: #selection)).
	self assert: (presentation validate: $b on: (pane port: #selection)).
	self deny: (presentation validate: $z on: (pane port: #selection)).! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testValidatePorts
	| pane presentation |
	pane := GLMPane named: 'test'.
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation shouldValidate: true.
	presentation entity: #(1 2).
	presentation selection: 2.
	self assert: presentation selection equals: 2.
	presentation selection: 3.	"this should be invalid"
	self assert: presentation selection equals: 2! !

!GLMListPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:50'!
testValidateWithMultipleSelection
	| pane presentation |
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	presentation beMultiple.
	presentation shouldValidate: true.
	pane addPresentation: presentation.
	presentation entity: ($a to: $d).
	self assert: (presentation validate: (Array with: $a) on: (pane port: #selection)).
	self assert: (presentation validate: (Array with: $a with: $b) on: (pane port: #selection)).
	self deny: (presentation validate: ($a) on: (pane port: #selection)).
	self deny: (presentation validate: (Array with: $z) on: (pane port: #selection)).! !

TestCase subclass: #GLMLoggerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMLoggerTest methodsFor: 'tests' stamp: 'tg 5/24/2010 17:13'!
testCustomInstance
	| memoryLogger |
	self assert: GLMLogger instance == GLMLogger nullInstance.
	memoryLogger := GLMMemoryLogger new.
	GLMLogger instance: memoryLogger.
	self assert: GLMLogger instance == memoryLogger.
	GLMLogger reset.
	self assert: GLMLogger instance == GLMLogger nullInstance! !

!GLMLoggerTest methodsFor: 'tests' stamp: 'tg 5/24/2010 17:17'!
testDefault
	GLMLoggedObject withAllSubclassesDo: [ :each |
		self assert: each new logger == GLMLogger nullInstance ]! !

TestCase subclass: #GLMMondrianPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMMondrianPresentationTest methodsFor: 'tests' stamp: 'tg 1/18/2010 20:27'!
testPaintingTakesPresentation
	| presentation viewRenderer  viewParameter mondrianParameter |
	presentation := GLMMondrianPresentation new.
	viewRenderer := MOViewRenderer new.
	presentation painting: [:view :entity :mondrian | viewParameter := view. mondrianParameter := mondrian ].
	presentation renderOn: viewRenderer.
	self assert: mondrianParameter notNil.
	self assert: mondrianParameter == presentation.
	self assert: viewParameter notNil.
	self assert: viewParameter == viewRenderer.! !

TestCase subclass: #GLMNestedBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testChangeInnerSelection
	"Tests setting the selection of an inner pane from the oustide. 
 
	The test sets up a browser with two panes. The first contains a 
	list of numbers, the second a browser which again contains one 
	pane with a list of the same numbers. When the selection in the 
	first pane changes, we want the same number to be selected in 
	the second pane. 
 
	To achieve this, we pull in a port on the second pane and copy 
	it to the inner pane using a simple transmission."

	| browser1 browser2 list1 list2 |
	browser1 := GLMExplicitBrowser new.
	browser2 := GLMExplicitBrowser new.
	list1 := GLMListPresentation new.
	list2 := GLMListPresentation new.
	browser1 addNewPane.
	browser1 addNewPane.
	browser2 addNewPane.
	browser1 panes first addPresentation: list1.
	browser1 panes last addPresentation: browser2.
	browser2 panes first addPresentation: list2.
	browser1
		addTransmission:
			((GLMTransmission new)
				addActiveOrigin: (browser1 panes first port: #selection);
				destination: (browser1 panes last port: #innerSelection);
				yourself).
	browser2
		addTransmission:
			((GLMTransmission new)
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								presentation: browser2;
								name: #innerSelection;
								yourself);
				destination: (browser2 panes first port: #selection);
				yourself).
	list1 entity: #(1 2 3).
	list2 entity: #(1 2 3).
	list1 selection: 1.
	self assert: list2 selection equals: 1.
	list1 selection: 2.
	self assert: list2 selection equals: 2! !

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCondition
	"This tests that the nested browser is controlled by the condition"

	| browser1 browser2 transmission1 |
	browser1 := GLMExplicitBrowser new.
	browser2 := GLMExplicitBrowser new.
	browser1 title: 'browser1'.
	browser2 title: 'browser2'.
	browser2
		transformation: [ :x | 
					x = 42
						ifFalse: [ 
							self fail.
							42 ]
						ifTrue: [ 84 ] ];
		condition: [ :x | x = 42 ].
	browser1 addNewPane name: 'pane1'.
	transmission1 := GLMTransmission new ensureReplacePresentationsStrategy.
	transmission1 transmissionStrategy addPresentation: browser2.
	browser1
		addTransmission:
			(transmission1
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								presentation: browser1;
								name: #entity;
								yourself);
				destination: (browser1 panes first port: #entity);
				yourself).
	self assert: (browser1 pane port: #entity) value isNil.
	self assert: (browser1 panes first port: #entity) value isNil.
	self assert: browser1 panes first presentations isEmpty.
	(browser1 pane port: #entity) value: 41.
	self assert: (browser1 pane port: #entity) value equals: 41.
	self assert: (browser1 panes first port: #entity) value equals: 41.
	self assert: browser1 panes first presentations size equals: 1.
	self assert: browser1 panes first matchingPresentations size equals: 0.
	(browser1 pane port: #entity) value: 42.
	self assert: (browser1 pane port: #entity) value equals: 42.	"	self assert: (browser1 panes first port: #entity) presentations value = 84.
"
	self assert: browser1 panes first presentations size equals: 1.
	self assert: browser1 panes first matchingPresentations size equals: 1! !

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testEntityPropogation
	"This tests that the nested transmissions have the destination correctly set 
	to be in the pane from the outer browser."

	| browser1 browser2 presentation innerBrowser transmission1 transmission2 |
	browser1 := GLMExplicitBrowser new.
	browser2 := GLMExplicitBrowser new.
	presentation := GLMPresentation new.
	browser1 title: 'browser1'.
	browser2 title: 'browser2'.
	browser1 addNewPane name: 'pane1'.
	browser2 addNewPane name: 'innerpane 1'.	"Jumpstart presentation for outer browser."
	transmission1 := GLMTransmission new ensureReplacePresentationsStrategy.
	transmission1 transmissionStrategy addPresentation: browser2.
	browser1
		addTransmission:
			(transmission1
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								presentation: browser1;
								name: #entity;
								yourself);
				destination: (browser1 panes first port: #entity);
				yourself).	"Jumpstart presentation for inner browser."
	transmission2 := GLMTransmission new ensureReplacePresentationsStrategy.
	transmission2 transmissionStrategy addPresentation: presentation.
	browser2
		addTransmission:
			(transmission2
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								presentation: browser2;
								name: #entity;
								yourself);
				destination: (browser2 panes first port: #entity);
				yourself).
	self assert: (browser1 pane port: #entity) value isNil.
	self assert: browser1 panes size equals: 1.
	self assert: (browser1 panes first port: #entity) value isNil.
	self assert: browser1 panes first presentations isEmpty.
	self assert: browser2 panes size equals: 1.
	self assert: (browser2 panes first port: #entity) value isNil.
	self assert: browser2 panes first presentations isEmpty.
	(browser1 pane port: #entity) value: 42.
	self assert: (browser1 pane port: #entity) value equals: 42.
	self assert: browser1 panes size equals: 1.
	self assert: (browser1 panes first port: #entity) value equals: 42.
	self assert: browser1 panes first presentations size equals: 1.
	innerBrowser := browser1 panes first presentations first.
	self assert: innerBrowser rootPrototype equals: browser2.
	self assert: innerBrowser pane == browser1 panes first.
	self assert: innerBrowser panes size equals: 1.
	self assert: (innerBrowser panes first port: #entity) value equals: 42.
	self assert: innerBrowser panes first presentations size equals: 1.
	self assert: innerBrowser panes first presentations first rootPrototype equals: presentation! !

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testInnerTransmissions
	"This tests that the nested transmissions have the destination correctly set 
	to be in the pane from the outer browser."

	| browser1 browser2 presentation innerBrowser |
	browser1 := GLMExplicitBrowser new.
	browser2 := GLMExplicitBrowser new.
	presentation := GLMPresentation new.
	browser1 addNewPane name: 'pane1'.
	browser2 addNewPane name: 'innerpane 1'.	"Jumpstart presentation for outer browser."
	browser1
		addTransmission:
			((GLMTransmission new)
				ensureReplacePresentationsStrategy;
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								presentation: browser1;
								name: #entity;
								yourself);
				destination: (browser1 panes first port: #entity);
				addPresentation: browser2;
				yourself).	"Jumpstart presentation for inner browser."
	browser2
		addTransmission:
			((GLMTransmission new)
				ensureReplacePresentationsStrategy;
				addActiveOrigin:
						((GLMPresentationBoundPort new)
								presentation: browser2;
								name: #entity;
								yourself);
				destination: (browser2 panes first port: #entity);
				addPresentation: presentation;
				yourself).
	(browser1 pane port: #entity) value: 42.
	innerBrowser := browser1 panes first presentations first.
	self assert: innerBrowser transmissions size equals: 1.
	self assert: (innerBrowser transmissions first origins first isKindOf: GLMPresentationBoundPort).
	self assert: innerBrowser transmissions first origins first pane == browser1 panes first! !

!GLMNestedBrowserTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testNestedBrowsersWithMultipleOrigins
	| browser innerBrowser transmittedOne transmittedTwo |
	innerBrowser := GLMTabulator new.
	innerBrowser row: #inner.
	(innerBrowser transmit)
		to: #inner;
		andShow: [ :a | a text ].
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	(browser transmit)
		to: #three;
		from: #one;
		from: #two;
		andShow: [ :a | 
					a
						custom:
							(innerBrowser
								display: [ :one :two | 
									transmittedOne := one.
									transmittedTwo := two ]) ].
	browser startOn: 1.
	((browser paneNamed: #one) port: #selection) value: 1.
	((browser paneNamed: #two) port: #selection) value: 2.
	self assert: transmittedOne equals: 1.
	self assert: transmittedTwo equals: 2! !

TestCase subclass: #GLMNewScriptingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testBuildingNestedComposites
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a list.
					a text.
					a
						composite: [ :another | 
							another text.
							another list ] ].
	browser startOn: 42.
	self assert: ((browser paneNamed: #one) presentations isKindOf: GLMCompositePresentation).
	self assert: (browser paneNamed: #one) presentations size equals: 3.
	self assert: ((browser paneNamed: #one) presentations last isKindOf: GLMCompositePresentation).
	self assert: (browser paneNamed: #one) presentations last size equals: 2! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testBundleTransmission
	| browser transmission |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	(browser transmit)
		from: #one port: #port1;
		from: #two port: #port2;
		to: #three -> #port3;
		andShow: [ :a | 
					a list.
					a table ].
	transmission := browser transmissions first.
	self assert: browser transmissions size equals: 1.
	self assert: transmission browser == browser.
	self assert: (transmission transmissionStrategy isKindOf: GLMReplacePresentationsStrategy).
	self assert: transmission origins size equals: 2.
	self assert: transmission origins first equals: ((browser paneNamed: #one) port: #port1).
	self assert: transmission origins last equals: ((browser paneNamed: #two) port: #port2).
	self assert: transmission destination equals: ((browser paneNamed: #three) port: #port3).
	self assert: (transmission transmissionStrategy presentations isKindOf: GLMCompositePresentation).
	self assert: transmission transmissionStrategy presentations size equals: 2! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testBundleTransmissionWithTransformation
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	(browser transmit)
		to: #one;
		andShow: [ :a | a text ].
	(browser transmit)
		from: #one transformed: [ :x | x + 1 ];
		to: #two;
		andShow: [ :a | a text ].
	browser startOn: 1.
	((browser paneNamed: #one) port: #selection) value: 41.
	self assert: ((browser paneNamed: #two) port: #entity) value equals: 42! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testEntity
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list ].
	browser startOn: ($a to: $d).
	self assert: ((browser paneNamed: #one) port: #entity) value equals: ($a to: $d)! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'tg 1/14/2010 23:00'!
testNestedCompositesPaneReference
	| browser | 
	browser := GLMTabulator new. 
	browser column: #one. 
	browser transmit to: #one; andShow: [ :a |
		a list.
		a text.
		a composite: [:another | 
			another text.
			another list ] ].
	browser startOn: 42.
	(browser paneNamed: #one) presentations do: [:each |
		self assert: each pane == (browser paneNamed: #one) ].
	(browser paneNamed: #one) presentations last do: [:each |
		self assert: each pane == (browser paneNamed: #one) ]! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSelectionValidation
	| browser |
	browser := GLMTabulator new.
	browser
		column: [ :c | 
					c
						row: #one;
						row: #two ];
		column: #three.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list display: [ :x | 1 to: x ] ].
	(browser transmit)
		to: #two;
		from: #one;
		andShow: [ :a | 
					(a list)
						beMultiple;
						display: [ :x | 1 to: x ] ].
	(browser transmit)
		to: #three;
		from: #two;
		andShow: [ :a | a text ].
	browser startOn: 42.
	((browser paneNamed: #one) port: #selection) value: 40.
	self assert: ((browser paneNamed: #two) port: #entity) value equals: 40.
	((browser paneNamed: #two) port: #selection) value: #(10 30 40).
	self assert: ((browser paneNamed: #two) port: #selection) value equals: #(10 30 40).
	self assert: ((browser paneNamed: #three) port: #entity) value equals: #(10 30 40).
	((browser paneNamed: #two) port: #selection) value: #(10 30).
	self assert: ((browser paneNamed: #two) port: #selection) value equals: #(10 30).
	self assert: ((browser paneNamed: #three) port: #entity) value equals: #(10 30).
	((browser paneNamed: #one) port: #selection) value: 5.
	self assert: ((browser paneNamed: #two) port: #entity) value equals: 5.
	((browser paneNamed: #two) port: #selection) value: #(1 3).
	self assert: ((browser paneNamed: #two) port: #selection) value equals: #(1 3).
	self assert: ((browser paneNamed: #three) port: #entity) value equals: #(1 3)! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 5/20/2012 00:52'!
testSimpleTransmission
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	(browser transmit)
		from: #one port: #port1;
		fromOutsidePort: #outerPort;
		to: #two port: #port2.
	(browser transmit)
		from: #one port: #port3;
		toOutsidePort: #anotherOuterPort.
	self assert: browser transmissions size equals: 2.
	self assert: browser transmissions first browser == browser.
	self assert: (browser transmissions first transmissionStrategy isKindOf: GLMNoStrategy).
	self assert: browser transmissions first origins first equals: ((browser paneNamed: #one) port: #port1).
	self assert: browser transmissions first origins last equals: (browser pane port: #outerPort).
	self assert: browser transmissions first destination equals: ((browser paneNamed: #two) port: #port2).
	self assert: browser transmissions last browser == browser.
	self assert: (browser transmissions last transmissionStrategy isKindOf: GLMNoStrategy).
	self assert: browser transmissions last origins first equals: ((browser paneNamed: #one) port: #port3).
	self assert: browser transmissions last destination equals: (browser pane port: #anotherOuterPort)! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 5/20/2012 00:54'!
testSimpleTransmissionWithCondition
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	(browser transmit)
		from: #one port: #port1;
		fromOutsidePort: #entity;
		to: #two port: #port2;
		when: [ :one :outer | one notNil and: [ outer notNil and: [ one + outer = 42 ] ] ].
	browser startOn: 2.
	self assert: ((browser paneNamed: #two) port: #port2) value isNil.
	((browser paneNamed: #one) port: #port1) value: 39.
	self assert: ((browser paneNamed: #two) port: #port2) value isNil.
	((browser paneNamed: #one) port: #port1) value: 40.
	self assert: ((browser paneNamed: #two) port: #port2) value notNil! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 5/20/2012 00:54'!
testSimpleTransmissionWithTransformation
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	(browser transmit)
		from: #one port: #port1;
		fromOutsidePort: #entity;
		to: #two port: #port2;
		when: [ :one :outer | one notNil and: [ outer notNil ] ];
		transformed: [ :one :outer | one + outer ].
	browser startOn: 2.
	self assert: ((browser paneNamed: #two) port: #port2) value isNil.
	((browser paneNamed: #one) port: #port1) value: 40.
	self assert: ((browser paneNamed: #two) port: #port2) value equals: 42! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testStartTabulator
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a list.
					a text ].
	browser startOn: 42.
	self assert: ((browser paneNamed: #one) presentations isKindOf: GLMCompositePresentation).
	self assert: (browser paneNamed: #one) presentations size equals: 2! !

!GLMNewScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testStatusbar
	| browser |
	browser := GLMTabulator withStatusbar.
	browser row: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list display: #(1 2 3) ].
	self assert: browser transmissions size equals: 2.
	browser startOn: 42! !

TestCase subclass: #GLMNoBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMNoBrowserTest methodsFor: 'tests' stamp: 'jorge.ressia 6/3/2009 08:35'!
testCreation

	self deny: GLMNoBrowser new isNil.
	self assert: (GLMNoBrowser new) == GLMNoBrowser new! !

TestCase subclass: #GLMPaneTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMPaneTest methodsFor: 'tests' stamp: 'tg 1/12/2010 13:53'!
expectedFailures
	^ #(testPortsInmmutability testPresentationsInmmutability)! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAllRecursivePresentations
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | a text ].
	browser startOn: 42.
	self assert: browser panes first withAllPresentations size equals: 2.
	self assert: browser pane withAllPresentations size equals: 4! !

!GLMPaneTest methodsFor: 'tests' stamp: 'TudorGirba 12/5/2011 13:29'!
testCachedMatchingPresentations
	| aPane cachedMatchingPresentations |
	aPane := GLMPane in: nil.
	cachedMatchingPresentations := aPane cachedMatchingPresentations.
	self assert: cachedMatchingPresentations == aPane cachedMatchingPresentations.
	aPane matchingPresentations "this should refresh cached matching presentations".
	self assert: cachedMatchingPresentations ~~ aPane cachedMatchingPresentations! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCopyAnnouncements
	| pane newPane |
	pane := GLMPane new.
	pane when: GLMPresentationsChanged do: [ :ann | self fail ].
	self assert: pane numberOfSubscriptions equals: 1.
	newPane := pane copy.
	newPane announce: GLMPresentationsChanged.
	self assert: newPane numberOfSubscriptions equals: 0! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCopyAnnouncementsDoNotRaise
	| pane newPane |
	pane := GLMPane new.
	pane when: GLMPresentationsChanged do: [ :ann | self fail ].
	self assert: pane numberOfSubscriptions equals: 1.
	newPane := pane copy.
	newPane announce: GLMPresentationsChanged.
	self assert: newPane numberOfSubscriptions equals: 0! !

!GLMPaneTest methodsFor: 'tests' stamp: 'TudorGirba 7/11/2011 11:11'!
testCopyNotTheSameRegistry

	| pane newPane |
	pane := GLMPane new.
	newPane := pane copy.
	self assert: pane glmSubscriptions ~~ newPane glmSubscriptions! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCreation
	| aPane |
	aPane := GLMPane named: 1 in: 2.
	self assert: aPane name equals: 1.
	self assert: aPane browser equals: 2! !

!GLMPaneTest methodsFor: 'tests' stamp: 'TudorGirba 7/9/2011 19:57'!
testDefaultCompositePresentation

 	| pane |
	pane := GLMPane named: 'test'. 
	self assert: (pane presentations isKindOf: GLMCompositePresentation)! !

!GLMPaneTest methodsFor: 'tests' stamp: 'tg 11/12/2009 22:01'!
testDefaultPortValue
	| pane |
	pane := GLMPane named: 'test'.
	self assert: (pane port: #somePort) value isNil! !

!GLMPaneTest methodsFor: 'tests' stamp: 'tg 1/5/2010 21:07'!
testDefaultPresentations
	| pane |
	pane := GLMPane named: 'test'.
	self assert: (pane presentations isKindOf: GLMCompositePresentation)! !

!GLMPaneTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:53'!
testDefaultValidate
	| pane |
	pane := GLMPane named: 'test'. 
	self assert: ((pane port: #selection) validate: 5)
! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testIn
	| aPane |
	aPane := GLMPane in: 1.
	self assert: aPane name equals: aPane defaultName.
	self assert: aPane browser equals: 1.
	self assert: aPane ports isEmpty.
	self assert: aPane presentations isEmpty! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testNamed
	| aPane |
	aPane := GLMPane named: 1.
	self assert: aPane name equals: 1.
	self assert: aPane browser equals: GLMNoBrowser new.
	self assert: aPane ports isEmpty.
	self assert: aPane presentations isEmpty! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testNamedIn
	| aPane |
	aPane := GLMPane named: 1 in: 2.
	self assert: aPane name equals: 1.
	self assert: aPane browser equals: 2.
	self assert: aPane ports isEmpty.
	self assert: aPane presentations isEmpty! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPorts
	| pane port |
	pane := GLMPane named: 'test'.
	self assert: pane ports isEmpty.
	port := pane port: #foo.
	self assert: pane ports size equals: 1.
	self assert: pane ports first == port.
	self assert: (pane port: #foo) == port! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPortsInmmutability
	| aPane ports |
	aPane := GLMPane in: 1.
	self assert: aPane ports isEmpty.
	ports := aPane ports.
	ports add: 1.
	self assert: ports size equals: 1.
	self assert: aPane ports isEmpty! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentationAndBrowserConditions
	| pane presentation1 presentation2 presentation3 |
	pane := GLMPane named: 'test'.
	presentation1 := GLMExplicitBrowser new condition: [ :first :second | first = 1 and: [ second = 2 ] ].
	presentation2 := GLMTabulator new condition: [ :first | first = #foo ].
	presentation3 := GLMExplicitBrowser new useExplicitNotNil.
	pane addPresentation: presentation1.
	pane addPresentation: presentation2.
	pane addPresentation: presentation3.
	(pane port: #entity) value: (GLMMultiValue withAll: #(1 2)).
	self assert: pane matchingPresentations size equals: 2.
	self assert: pane matchingPresentations first == presentation1.
	self assert: pane matchingPresentations last == presentation3.
	(pane port: #entity) value: (GLMMultiValue withAll: #(#foo 2)).
	self assert: pane matchingPresentations size equals: 2.
	self assert: pane matchingPresentations first == presentation2.
	self assert: pane matchingPresentations last == presentation3.
	(pane port: #entity) value: (GLMMultiValue withAll: #(nil 2)).
	self assert: pane matchingPresentations size equals: 1! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentationConditions
	| pane presentation1 presentation2 presentation3 |
	pane := GLMPane named: 'test'.
	presentation1 := GLMPresentation new condition: [ :first :second | first = 1 and: [ second = 2 ] ].
	presentation2 := GLMPresentation new condition: [ :first | first = #foo ].
	presentation3 := GLMPresentation new useExplicitNotNil.
	pane addPresentation: presentation1.
	pane addPresentation: presentation2.
	pane addPresentation: presentation3.
	(pane port: #entity) value: (GLMMultiValue withAll: #(1 2)).
	self assert: pane matchingPresentations size equals: 2.
	self assert: pane matchingPresentations first == presentation1.
	self assert: pane matchingPresentations last == presentation3.
	(pane port: #entity) value: (GLMMultiValue withAll: #(#foo 2)).
	self assert: pane matchingPresentations size equals: 2.
	self assert: pane matchingPresentations first == presentation2.
	self assert: pane matchingPresentations last == presentation3.
	(pane port: #entity) value: (GLMMultiValue withAll: #(nil 2)).
	self assert: pane matchingPresentations size equals: 1! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentations
	| pane presentation announcement |
	pane := GLMPane named: 'test'.
	presentation := GLMPresentation new.
	self assert: pane presentations isEmpty.
	announcement := nil.
	pane when: GLMPresentationsChanged do: [ :ann | announcement := ann ].
	pane addPresentation: presentation.
	self assert: pane presentations size equals: 1.
	self assert: pane presentations first == presentation.
	self assert: presentation pane == pane.
	self assert: announcement notNil! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentationsInmmutability
	| aPane presentations |
	aPane := GLMPane in: 1.
	self assert: aPane presentations isEmpty.
	presentations := aPane presentations.
	presentations add: 1.
	self assert: presentations size equals: 1.
	self assert: aPane presentations isEmpty! !

!GLMPaneTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimplePresentations
	| pane presentation announcement |
	pane := GLMPane named: 'test'.
	presentation := GLMPresentation new.
	self assert: pane presentations isEmpty.
	announcement := nil.
	pane when: GLMPresentationsChanged do: [ :ann | announcement := ann ].
	pane addPresentation: presentation.
	self assert: pane presentations size equals: 1.
	self assert: pane presentations first == presentation.
	self assert: presentation pane == pane.
	self assert: announcement notNil! !

!GLMPaneTest methodsFor: 'tests' stamp: 'lr 6/4/2010 13:53'!
testValidate
	| pane presentation |
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation entity: (OrderedCollection with: 1 with: 2).
	presentation shouldValidate: true.
	self assert: ((pane port: #selection) validate: 1).
	self assert: ((pane port: #selection) validate: 2).
	self deny: ((pane port: #selection) validate: 5)
! !

TestCase subclass: #GLMPortEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMPortEventTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCreation
	| anEvent |
	anEvent := GLMPortEvent on: 1 previouslyValued: 2.
	self assert: anEvent port equals: 1.
	self assert: anEvent oldValue equals: 2.
	self assert: anEvent transmissionContext isEmpty! !

!GLMPortEventTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCreationWithTransmissionContext
	| anEvent aContext |
	aContext := OrderedCollection new.
	anEvent := GLMPortEvent on: 1 previouslyValued: 2 in: aContext.
	self assert: anEvent port equals: 1.
	self assert: anEvent oldValue equals: 2.
	self assert: anEvent transmissionContext equals: aContext! !

!GLMPortEventTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:22'!
testInterdependentPanesCycleBreak
	| browser outerCount oneCount |
	outerCount := 0.
	oneCount := 0.
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	browser
		transmit to: #one;
		andShow: [ :a | a list display: [ :x | 1 to: x ] ].
	browser
		transmit to: #two;
		from: #one;
		andShow: [ :a | a list display: [ :x | 1 to: x * 2 ] ].
	browser
		transmit to: #three;
		from: #two;
		andShow: [ :a |  
					(a list)
						display: [ :x | 1 to: x * 3 ];
						populate: #focus
							on: $f
							entitled: 'Focus'
							with: [ :list | list selection ] ].
	browser transmit toOutsidePort: #focus; from: #three port: #focus; transformed: [ :x | outerCount := outerCount + 1 ].
	browser transmit to: #one port: #selection; fromOutsidePort: #focus; transformed: [ :x | oneCount := oneCount + 1 ].
	browser startOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.
	((browser paneNamed: #three) port: #selection) value: 12.
	((browser paneNamed: #three) port: #focus) value: 12.
	self assert: oneCount equals: 1.
	self assert: outerCount equals: 1! !

!GLMPortEventTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:21'!
testInterdependentPanesProperPorts
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	browser
		transmit to: #one;
		andShow: [ :a | a list display: [ :x | 1 to: x ] ].
	browser
		transmit to: #two;
		from: #one;
		andShow: [ :a | a list display: [ :x | 1 to: x * 2 ] ].
	browser
		transmit to: #three;
		from: #two;
		andShow: [ :a | 
					(a list)
						display: [ :x | 1 to: x * 3 ];
						populate: #focus
							on: $f
							entitled: 'Focus'
							with: [ :list | list selection ] ].
	browser transmit toOutsidePort: #focus; from: #three port: #focus.
	browser transmit to: #one port: #selection; fromOutsidePort: #focus; transformed: [ :x | x + 1 ].
	browser transmit to: #two port: #selection; fromOutsidePort: #focus; transformed: [ :x | x + 2 ].
	browser startOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.
	((browser paneNamed: #three) port: #selection) value: 12.
	((browser paneNamed: #three) port: #focus) value: 12.
	self assert: (browser pane port: #focus) value equals: 12.
	self assert: ((browser paneNamed: #one) port: #entity) value equals: 5.
	self assert: ((browser paneNamed: #one) port: #selection) value equals: 13.
	self assert: ((browser paneNamed: #two) port: #entity) value equals: 13.
	self assert: ((browser paneNamed: #two) port: #selection) value equals: 14.
	self assert: ((browser paneNamed: #three) port: #entity) value equals: 14.
	self assert: ((browser paneNamed: #three) port: #selection) value equals: nil! !

!GLMPortEventTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPortName
	| anEvent |
	anEvent := GLMPortEvent
		on:
			((GLMPort new)
				name: '1';
				yourself)
		previouslyValued: 2.
	self assert: anEvent portName equals: '1'! !

TestCase subclass: #GLMPortIdentifierTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMPortIdentifierTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAsOriginIdentifier
	| id |
	id := GLMPortIdentifier new.
	self assert: id asGlamourOriginIdentifier equals: id! !

!GLMPortIdentifierTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAsTargetIdentifier
	| id |
	id := GLMPortIdentifier new.
	self assert: id asGlamourTargetIdentifier equals: id! !

!GLMPortIdentifierTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAssociationAsOriginIdentifier
	self assert: ((#pane -> #port) asGlamourOriginIdentifier isKindOf: GLMPortIdentifier).
	self assert: (#pane -> #port) asGlamourOriginIdentifier paneName equals: #pane.
	self assert: (#pane -> #port) asGlamourOriginIdentifier portName equals: #port! !

!GLMPortIdentifierTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAssociationAsTargetIdentifier
	self assert: ((#pane -> #port) asGlamourTargetIdentifier isKindOf: GLMPortIdentifier).
	self assert: (#pane -> #port) asGlamourTargetIdentifier paneName equals: #pane.
	self assert: (#pane -> #port) asGlamourTargetIdentifier portName equals: #port! !

!GLMPortIdentifierTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSymbolAsOriginIdentifier
	self assert: (#pane asGlamourOriginIdentifier isKindOf: GLMPortIdentifier).
	self assert: #pane asGlamourOriginIdentifier paneName equals: #pane.
	self assert: #pane asGlamourOriginIdentifier portName equals: #selection! !

!GLMPortIdentifierTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSymbolAsTargetIdentifier
	self assert: (#pane asGlamourTargetIdentifier isKindOf: GLMPortIdentifier).
	self assert: #pane asGlamourTargetIdentifier paneName equals: #pane.
	self assert: #pane asGlamourTargetIdentifier portName equals: #entity! !

TestCase subclass: #GLMPortReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMPortReferenceTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testOriginTransformedValue
	| port reference |
	port := GLMSimplePort new value: 41.
	reference := (GLMOriginPortReference new)
		port: port;
		transformation: [ :x | x + 1 ].
	self assert: reference value equals: 42! !

!GLMPortReferenceTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testOriginValue
	| port reference |
	port := GLMSimplePort new value: 42.
	reference := GLMOriginPortReference new port: port.
	self assert: reference value equals: 42! !

TestCase subclass: #GLMPortTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMPortTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPanePortTransmissionCallingReceiveIn
	| originPort destinationPort transmission |
	originPort := GLMTestPane new port: #originPort.
	destinationPort := GLMTestPane new port: #destinationPort.
	self assert: destinationPort seenTransmissions isEmpty.
	transmission := (GLMTransmission new)
		addActiveOrigin: originPort;
		destination: destinationPort;
		transformation: [ :x | x + 1 ].
	originPort value: 41.
	transmission transmit.
	self assert: destinationPort seenTransmissions size equals: 1.
	self assert: destinationPort seenTransmissions first origins first value equals: 41.
	self assert: destinationPort seenTransmissions first destination == destinationPort.
	self assert: destinationPort value equals: 42! !

!GLMPortTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPortEquality
	| presentation port |
	presentation := GLMPresentation new.
	port := (GLMPresentationBoundPort new)
		name: #port;
		presentation: presentation.
	self assert: port equals: (presentation pane port: #port).
	self assert: (presentation pane port: #port) equals: port.
	self assert: port hash equals: (presentation pane port: #port) hash.
	self assert: (presentation pane port: #port) hash equals: port hash! !

!GLMPortTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPresentationBoundPort
	| presentation port |
	presentation := GLMPresentation new.
	port := (GLMPresentationBoundPort new)
		name: #port;
		presentation: presentation.
	port value: 42.
	self assert: (presentation pane port: #port) value equals: 42.
	(presentation pane port: #port) value: 43.
	self assert: port value equals: 43! !

!GLMPortTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testResetValue
	| port |
	port := GLMTestPane new port: #port1.
	port value: 42.
	self assert: port value equals: 42.
	port resetValue.
	self assert: port value isNil! !

!GLMPortTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimplePort
	| port |
	port := GLMSimplePort new.
	port name: #foo.
	port value: 42.
	self assert: port name equals: #foo.
	self assert: port value equals: 42.
	self assert: port hasPane not! !

!GLMPortTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testTransientValue
	| port pane browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	(browser transmit)
		fromOutsidePort: #entity;
		to: #one port: #entity.
	(browser transmit)
		from: #one port: #entity;
		to: #two;
		andShow: [ :a | a text ].
	browser startOn: 42.
	self assert: (browser panes first port: #entity) value equals: 42.
	self assert: (browser panes last port: #entity) value equals: 42.
	(browser panes first port: #entity) transientValue: 43.
	self assert: (browser pane port: #entity) value equals: 42.
	self assert: (browser panes first port: #entity) value equals: 42.
	self assert: (browser panes last port: #entity) value equals: 43.
	(browser pane port: #entity) transientValue: 44.
	self assert: (browser pane port: #entity) value equals: 42.
	self assert: (browser panes first port: #entity) value equals: 44.
	self assert: (browser panes last port: #entity) value equals: 44! !

TestCase subclass: #GLMPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMPresentationTest methodsFor: 'testing' stamp: 'DamienCassou 7/19/2011 20:38'!
expectedFailures 
	^ #(testToSendMultipleValue)! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 11/19/2010 18:27'!
testActions
	| listing |
	listing := GLMPresentation new.
	listing actions isEmpty.
	listing addAction: GLMAction new.
	listing actions size = 1.! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAllActions
	| listing |
	listing := GLMPresentation new.
	self assert: listing hasActions not.
	listing addAction: GLMAction new.
	listing addAction: GLMAction new.
	listing dynamicActions: [ :p | OrderedCollection with: GLMAction new with: GLMAction new with: GLMAction new ].
	self assert: listing allActions size equals: 5.
	self assert: listing hasActions! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAllSelectionActions
	| listing |
	listing := GLMPresentation new.
	listing addSelectionAction: GLMAction new.
	listing addSelectionAction: GLMAction new.
	listing
		dynamicActionsOnSelection: [ :p | OrderedCollection with: GLMAction new with: GLMAction new with: GLMAction new ].
	self assert: listing allSelectionActions size equals: 5! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testAnnouncement
	| pane presentation announcement |
	pane := GLMPane named: 'test'.
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	announcement := nil.
	presentation when: GLMContextChanged do: [ :ann | announcement := ann ].
	(pane port: #entity) value: 42.
	self assert: announcement notNil.
	self assert: announcement property equals: #entity.
	self assert: announcement value equals: 42! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testContext
	| pane presentation |
	pane := GLMPane named: 'test'.
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	presentation selection: 42.
	self assert: (pane port: #selection) value equals: 42.
	(pane port: #entity) value: 'foo'.
	self assert: presentation entity equals: 'foo'! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCopyAnnouncementsDoNotRaise
	| presentation newPresentation |
	presentation := GLMPresentation new.
	presentation when: GLMContextChanged do: [ :ann | self fail ].
	self assert: presentation numberOfSubscriptions equals: 1.
	newPresentation := presentation copy.
	newPresentation announce: GLMContextChanged.
	self assert: newPresentation numberOfSubscriptions equals: 0! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'TudorGirba 7/11/2011 11:10'!
testCopyNotTheSameRegistry

	| presentation newPresentation |
	presentation := GLMPresentation new.
	newPresentation := presentation copy.
	self assert: presentation glmSubscriptions ~~ newPresentation glmSubscriptions! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCopyRootPrototype
	| presentation newPresentation yetAnotherPresentation |
	presentation := GLMPresentation new.
	newPresentation := presentation copy.
	self assert: newPresentation rootPrototype equals: presentation.
	self assert: newPresentation parentPrototype equals: presentation.
	yetAnotherPresentation := newPresentation copy.
	self assert: yetAnotherPresentation rootPrototype equals: presentation.
	self assert: yetAnotherPresentation parentPrototype equals: newPresentation! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:16'!
testCopyTheTransformation
	| presentation newPresentation transformation |
	presentation := GLMPresentation new.
	presentation selectionTransformation: [:each | each + 1].
	newPresentation := presentation copy.
	self assert: (presentation selectionTransformation value: 1) equals: 2.
	self assert: (newPresentation selectionTransformation value: 1) equals: 2.! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 5/25/2010 23:09'!
testDefaultPane
	| presentation pane |
	presentation := GLMPresentation new.
	pane := presentation pane.
	self assert: pane presentations first pane == pane.
	self assert: pane presentations pane == pane.
	self assert: pane presentations first == presentation! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testDisplay
	| presentation |
	presentation := GLMPresentation new.
	presentation entity: #foo.
	self assert: presentation displayValue equals: #foo.
	presentation entity: #(#foo #bar).
	self assert: presentation displayValue equals: #(#foo #bar).
	presentation entity: (GLMMultiValue withAll: #(#foo #bar)).
	self assert: presentation displayValue equals: #foo.
	presentation transformation: [ :first :second | (first , second) asSymbol ].
	self assert: presentation displayValue equals: #foobar! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 8/22/2010 15:46'!
testEquality
	| presentation |
	presentation := GLMPresentation new.
	self assert: (presentation = presentation copy) not! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 12/31/2009 00:24'!
testExplicitNotNilMultipleValues
	| presentation | 
	presentation := GLMPresentation new. 
	presentation useExplicitNotNil.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil nil)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(1 nil)).
	self assert: presentation matches.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)).
	self assert: presentation matches.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(1 2)).
	self assert: presentation matches.! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 1/13/2010 22:28'!
testHasTitle
	| presentation |
	presentation := GLMPresentation new.
	self assert: presentation hasTitle not.
	presentation title: 'something'.
	self assert: presentation hasTitle! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 1/13/2010 22:30'!
testHasTitleIcon
	| presentation |
	presentation := GLMPresentation new.
	self assert: presentation hasTitleIcon not.
	presentation titleIcon: 'something'.
	self assert: presentation hasTitleIcon! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 12/16/2009 17:49'!
testImplicitNotNilMultipleValues
	| presentation | 
	presentation := GLMPresentation new. 
	presentation useImplicitNotNil.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil nil)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(1 nil)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(1 2)).
	self assert: presentation matches.! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testMatching
	| presentation |
	presentation := GLMPresentation new.
	self assert: presentation usesImplicitNotNil.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)).
	self assert: presentation matches not.
	(presentation pane port: #entity) value: 1.
	self assert: presentation matches.
	presentation useExplicitNotNil.
	self assert: presentation usesImplicitNotNil not.
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)).
	self assert: presentation matches.
	(presentation pane port: #entity) value: 1.
	self assert: presentation matches.
	presentation condition: [ :x | x > 1 ].
	presentation useImplicitNotNil.
	self assert: presentation usesImplicitNotNil.
	(presentation pane port: #entity) value: nil.
	self assert: presentation matches not.
	(presentation pane port: #entity) value: 1.
	self assert: presentation matches not.
	(presentation pane port: #entity) value: 2.
	self assert: presentation matches.
	presentation useExplicitNotNil.
	(presentation pane port: #entity) value: 1.
	self assert: presentation matches not.
	(presentation pane port: #entity) value: 2.
	self assert: presentation matches.
	self assert: presentation usesImplicitNotNil not.
	[ 
	(presentation pane port: #entity) value: (GLMMultiValue withAll: #(nil 1)).
	presentation matches.
	self signalFailure: 'Should have raised error' ]
		on: MessageNotUnderstood
		do: [ :err | 
			self assert: err message selector equals: #>.
			self assert: err message arguments equals: (Array with: 1) ]! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:03'!
testSelectionActions
	| listing |
	listing := GLMPresentation new.
	listing selectionActions isEmpty.
	listing addSelectionAction: GLMAction new.
	self assert: listing selectionActions size equals: 1.! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 1/5/2010 21:08'!
testSetup
	| presentation |
	presentation := GLMPresentation new. 
	self assert: presentation pane notNil. 
	self assert: (presentation pane presentations includes: presentation)! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testTitle
	| presentation |
	presentation := GLMPresentation new.
	presentation entity: #foo.
	self assert: presentation titleValue isNil.
	presentation title: '41'.
	self assert: presentation titleValue equals: '41'.
	presentation entity: '4'.
	presentation title: [ :x | x , '2' ].
	self assert: presentation titleValue equals: '42'.
	presentation entity: (GLMMultiValue withAll: #('4' '3')).
	presentation title: [ :first :second | first , second ].
	self assert: presentation titleValue equals: '43'! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'TudorGirba 9/24/2012 08:12'!
testToRawSelection
	| presentation |
	presentation := GLMPresentation new.

	presentation selection: 1.
	self assert: presentation selection equals: 1.
	self assert: presentation rawSelection equals: 1.
	
	presentation selectionTransformation: [ :num  | num + 1].
	presentation selection: 1.
	self assert: presentation selection equals: 2.
	self assert: presentation rawSelection equals: 1.! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 16:42'!
testToSend
	| presentation |
	presentation := GLMPresentation new.
	presentation selection: #foo.
	self assert: presentation selection equals: #foo.
	presentation selection: #(#foo #bar ).
	self assert: presentation selection equals: #(#foo #bar ).
	presentation selectionTransformation: [ :first :second | (first , second) asSymbol ].
	presentation selection: (GLMMultiValue withAll: #(#foo #bar )).
	self assert: presentation selection equals: #foobar! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testToSendAs
	| presentation |
	presentation := GLMPresentation new.
	presentation selection: #foo.
	self assert: presentation selection equals: #foo.
	self assert: (presentation pane port: #newport) value equals: nil.
	presentation send: [ :num | num + 1 ] as: #newport.
	presentation selection: 1.
	self assert: (presentation pane port: #newport) value equals: 2.
	self assert: presentation selection equals: 1! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 16:42'!
testToSendMultipleValue
	| presentation |
	presentation := GLMPresentation new.
	presentation selection: (GLMMultiValue withAll: #(#foo #bar )).
	self assert: presentation selection equals: #foo.
	presentation selectionTransformation: [ :first :second | (first , second) asSymbol ].! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testUnregisterAnnouncements
	| announcer presentation |
	announcer := Announcer new.
	presentation := GLMPresentation new.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	presentation registerAnnouncements.
	self assert: announcer numberOfSubscriptions equals: 1.
	presentation unregisterFromAllAnnouncements.
	self assert: announcer numberOfSubscriptions equals: 0! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testUnregisterAnnouncementsWhenEntityChanges
	| announcer1 presentation |
	announcer1 := Announcer new.
	presentation := GLMPresentation new.
	presentation updateOn: TestAnnouncement from: [ announcer1 ].
	presentation entity: 1.
	presentation registerAnnouncements.
	self assert: announcer1 numberOfSubscriptions equals: 1.
	presentation entity: 2.
	self assert: announcer1 numberOfSubscriptions equals: 0.
	presentation registerAnnouncements.
	self assert: announcer1 numberOfSubscriptions equals: 1.
	presentation entity: nil.
	self assert: announcer1 numberOfSubscriptions equals: 0! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testUpdate
	| col pane presentation |
	col := OrderedCollection with: 1 with: 2.
	pane := GLMPane named: 'test'.
	presentation := GLMListPresentation new.
	pane addPresentation: presentation.
	presentation entity: col.
	presentation shouldValidate: true.
	presentation update.
	presentation selection: 2.
	self assert: presentation selection equals: 2.
	col removeLast.
	presentation update.
	self assert: presentation selection isNil! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testUpdateConditionallyTriggered
	| pane presentation announcer timesTriggered |
	pane := GLMPane named: 'test'.
	(pane port: #entity) value: 40.
	presentation := GLMPresentation new.
	announcer := Announcer new.
	pane addPresentation: presentation.
	timesTriggered := 0.
	presentation when: GLMPresentationUpdated do: [ :announcement | timesTriggered := timesTriggered + 1 ].
	presentation updateOn: TestAnnouncement from: [ :x | announcer ] when: [ :ann :entity | ann parameter + entity = 42 ].
	presentation registerAnnouncements.
	announcer announce: (TestAnnouncement new parameter: 0).
	self assert: timesTriggered equals: 0.
	announcer announce: (TestAnnouncement new parameter: 2).
	self assert: timesTriggered equals: 1! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'tg 5/2/2010 23:38'!
testUpdateOnFromAllPortsUpdate
	| pane presentation announcers col updated |
	col := (1 to: 4) asOrderedCollection. 
	pane := GLMPane named: 'test'. 
	presentation := GLMListPresentation new.
	announcers := col collect: [:each | Announcer new].
	pane addPresentation: presentation.
	presentation updateOn: TestAnnouncement fromAll: [ announcers ].
	presentation when: GLMPresentationUpdated do: [:a | updated := true ].
	presentation entity: col.
	presentation shouldValidate: true.
	presentation registerAnnouncements.

	updated := false.
	announcers last announce: TestAnnouncement.
	self assert: updated.
	updated := false.
	announcers last announce: TestAnnouncement.
	self assert: updated.
! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testUpdateOnPortsUpdate
	| col pane presentation announcer |
	col := OrderedCollection with: 1 with: 2.
	pane := GLMPane named: 'test'.
	presentation := GLMListPresentation new.
	announcer := Announcer new.
	pane addPresentation: presentation.
	presentation updateOn: TestAnnouncement from: [ announcer ].
	presentation entity: col.
	presentation shouldValidate: true.
	presentation registerAnnouncements.
	presentation selection: 2.
	self assert: presentation selection equals: 2.
	col removeLast.
	announcer announce: TestAnnouncement.
	self assert: presentation selection isNil! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testUpdateOnTriggered
	| pane presentation announcer timesTriggered |
	pane := GLMPane named: 'test'.
	presentation := GLMPresentation new.
	announcer := Announcer new.
	pane addPresentation: presentation.
	timesTriggered := 0.
	presentation when: GLMPresentationUpdated do: [ :announcement | timesTriggered := timesTriggered + 1 ].
	presentation updateOn: TestAnnouncement from: #yourself.
	presentation entity: announcer.
	presentation registerAnnouncements.
	announcer announce: TestAnnouncement.
	self assert: timesTriggered equals: 1! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'lr 6/4/2010 14:03'!
testValidate
	| pane presentation | 
	pane := GLMPane named: 'test'. 
	presentation := GLMPresentation new.
	pane addPresentation: presentation.
	presentation entity: (OrderedCollection with: 1 with: 2).
	self assert: (presentation validate: 1 on: (pane port: #foo)).
	self assert: (presentation validate: 2 on: (pane port: #foo)).
	self assert: (presentation validate: 5 on: (pane port: #foo))
! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'TudorGirba 9/5/2011 19:11'!
testWith
	| p presentationInWithBlock |
	p := GLMPresentation new.
	p with: [ :thePresentation | presentationInWithBlock := thePresentation ].
	self assert: presentationInWithBlock == p! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 08:50'!
testWithBlockPassesTheParentPresentation
	| p presentationInWithBlock |
	p := GLMPresentation new.
	p with: [ :thePresentation | presentationInWithBlock := thePresentation ].
	self assert: presentationInWithBlock == p! !

!GLMPresentationTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 08:50'!
testWithReturnsTheOriginalPresentation
	| p result |
	p := GLMPresentation new.
	result := p with: [ :thePresentation | GLMPresentation new ].
	self assert: result == p! !

TestCase subclass: #GLMScriptingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 1/2/2012 02:45'!
expectedFailures 
	^ #(testFinderWithPreviousPort)! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:19'!
testActionDefinition
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser
		transmit to: #one;
		andShow: [ :a | 
					a text act: [  ] entitled: ''.
					a list act: [  ] entitled: ''.
					a tree act: [  ] entitled: '' ].
	browser startOn: #(42).
	browser panes first presentations do: [ :each | self assert: each actions size equals: 1 ]! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:19'!
testAllowNil
	| browser presentationsChanged matchingPresentationsChanged |
	browser := GLMTabulator new.
	browser
		column: [ :c | 
					c
						row: #one;
						row: #two ];
		column: #details.
	browser
		transmit to: #one;
		andShow: [ :a | a tree display: #(1 2 3) ].
	browser
		transmit to: #two;
		andShow: [ :a | a tree display: #(#a #b #c) ].
	browser
		transmit to: #details;
		from: #one;
		from: #two;
		andShow: [ :a | 
					(a text)
						display: [ :one :two | one asString , two asString ];
						allowNil ].
	browser startOn: 42.
	(browser paneNamed: #details) when: GLMPresentationsChanged do: [ :a | presentationsChanged := true ].
	(browser paneNamed: #details) when: GLMMatchingPresentationsChanged do: [ :a | matchingPresentationsChanged := true ].
	presentationsChanged := false.
	matchingPresentationsChanged := false.
	((browser paneNamed: #one) port: #selection) value: 2.
	self assert: presentationsChanged.
	self assert: matchingPresentationsChanged.
	self assert: (browser paneNamed: #details) presentations first displayValue equals: '2nil'.
	presentationsChanged := false.
	((browser paneNamed: #two) port: #selection) value: #c.
	self assert: presentationsChanged.
	self assert: matchingPresentationsChanged.
	self assert: (browser paneNamed: #details) presentations first displayValue equals: '2c'.
	presentationsChanged := false.
	((browser paneNamed: #one) port: #selection) value: nil.
	self assert: presentationsChanged.
	self assert: matchingPresentationsChanged.
	self assert: (browser paneNamed: #details) presentations first displayValue equals: 'nilc'! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:18'!
testConditionalPresentation
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	browser
		transmit to: #two;
		from: #one;
		andShow: [ :a | 
					a text when: [ :x | x = 42 ].
					a list when: [ :x | x > 42 ] ].
	((browser paneNamed: #one) port: #selection) value: 42.
	self assert: (browser paneNamed: #two) matchingPresentations size equals: 1.
	self assert: ((browser paneNamed: #two) matchingPresentations first isKindOf: GLMTextPresentation).
	((browser paneNamed: #one) port: #selection) value: 43.
	self assert: (browser paneNamed: #two) matchingPresentations size equals: 1.
	self assert: ((browser paneNamed: #two) matchingPresentations first isKindOf: GLMListPresentation)! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:18'!
testDynamicActions
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser
		transmit to: #one;
		andShow: [ :a | 
					(a list)
						display: [ :x | 1 to: x ];
						dynamicActions: [ :list | 
									(1 to: list selection)
										collect: [ :index | 
											(GLMGenericAction new)
												action: [ index ];
												title: 'Action' , index printString;
												yourself ] ] ].
	browser startOn: 42.
	(browser panes first port: #selection) value: 3.
	self assert: browser panes first presentations first dynamicActions size equals: 3.
	(browser panes first port: #selection) value: 5.
	self assert: browser panes first presentations first dynamicActions size equals: 5! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:18'!
testEntityInUpdateAction
	| browser inputFromActionBlock |
	browser := GLMTabulator new.
	browser column: #one.
	browser
		transmit to: #one;
		andShow: [ :a | a text populate: #foo on: $m with: [ :list :input | inputFromActionBlock := input ] ].
	browser startOn: 42.
	browser panes first presentations first actions first actOn: browser panes first presentations first.
	self assert: inputFromActionBlock equals: 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 1/2/2012 02:45'!
testFinderWithPreviousPort
	| browser |
	browser := GLMFinder new.
	browser show: [:a | 
		a list
			title: 'Presentation1';
			display: [ :each | 1 to: each ]].
	browser 
		fromPrevious: #selection;
		passivelyFromPrevious: #highlight;
		andShow: [ :a | 
			a list
				title: 'Presentation2';
				display: [ :selection :highlight | 1 to: selection + highlight ] ].
	browser startOn: 42.
	self assert: browser panes first presentations size equals: 1.
	self assert: browser presentations first title equals: 'Presentation1'.
	self assert: browser transmissions size equals: 1.
	self assert: browser transmissions last origins size equals: 2.
	self assert: browser transmissions last transmissionStrategy presentations size equals: 1.
	self assert: browser transmissions last transmissionStrategy presentations first title equals: 'Presentation2'.
	self assert: (browser panes first port: #entity) value equals: 42.
	(browser panes first port: #highlight) value: 43.
	(browser panes first port: #selection) value: 41.
	self assert: browser panes size equals: 2.
	self assert: browser panes last presentations size equals: 2.
	self assert: browser panes last presentations last displayValue size equals: 84.
	self assert: browser panes last presentations size equals: 2! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:17'!
testMorphicActionDefinition
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser
		transmit to: #one;
		andShow: [ :a | 
					a text morphicAct: [  ] entitled: ''.
					a list morphicAct: [  ] entitled: ''.
					a tree morphicAct: [  ] entitled: '' ].
	browser startOn: #(42).
	browser panes first presentations do: [ :each | self assert: each actions size equals: 1 ]! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testNestedBrowserEntity
	| browser innerBrowser realInnerBrowser |
	browser := GLMTabulator new.
	browser column: #one.
	innerBrowser := GLMTabulator new.
	innerBrowser column: #innerOne.
	(innerBrowser transmit)
		to: #innerOne;
		from: #outer port: #entity;
		andShow: [ :a | a text ].
	(browser transmit)
		to: #one;
		andShow: [ :a | (a custom: innerBrowser) display: [ :x | x + 2 ] ].
	browser startOn: 40.
	realInnerBrowser := (browser paneNamed: #one) presentations first.
	self assert: ((browser paneNamed: #one) port: #entity) value equals: 40.
	self assert: (realInnerBrowser pane port: #entity) value equals: 40.
	self assert: ((realInnerBrowser paneNamed: #innerOne) port: #entity) value equals: 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:17'!
testNestedBrowserOther
	| browser innerBrowser realInnerBrowser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	innerBrowser := GLMTabulator new.
	innerBrowser column: #innerOne.
	innerBrowser
		transmit to: #innerOne;
		andShow: [ :a | a text ].
	innerBrowser transmit toOutsidePort: #selection; from: #innerOne.
	browser
		transmit to: #one;
		andShow: [ :a | (a custom: innerBrowser) display: [ :x | x + 2 ] ].
	browser
		transmit to: #two;
		from: #one;
		andShow: [ :a | a text ].
	browser startOn: 40.
	realInnerBrowser := (browser paneNamed: #one) presentations first.
	self assert: ((browser paneNamed: #one) port: #entity) value equals: 40.
	self assert: (realInnerBrowser pane port: #entity) value equals: 40.
	self assert: ((realInnerBrowser paneNamed: #innerOne) port: #entity) value equals: 42.
	(realInnerBrowser panes first port: #selection) value: 7.
	self assert: (realInnerBrowser pane port: #selection) value equals: 7.
	self assert: (browser panes last port: #entity) value equals: 7! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testNestedBrowserWithExplicitTransmission
	| browser innerBrowser realInnerBrowser |
	browser := GLMTabulator new.
	browser column: #one.
	innerBrowser := GLMTabulator new.
	innerBrowser column: #innerOne.
	(innerBrowser transmit)
		to: #innerOne;
		from: #outer port: #entity;
		andShow: [ :a | a text ].
	(browser transmit)
		to: #one;
		andShow: [ :a | a custom: innerBrowser ].
	browser startOn: 42.
	realInnerBrowser := (browser paneNamed: #one) presentations first.
	self assert: ((browser paneNamed: #one) port: #entity) value equals: 42.
	self assert: ((realInnerBrowser paneNamed: #innerOne) port: #entity) value equals: 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:16'!
testOuterEntity
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	browser
		transmit to: #one;
		andShow: [ :a | a text ].
	browser
		transmit to: #two;
		fromOutsidePort: #entity;
		andShow: [ :a | a text ].
	browser startOn: 42.
	self assert: browser transmissions first origins anyOne name equals: #entity.
	self assert: browser transmissions last origins anyOne name equals: #entity.
	self assert: browser transmissions size equals: 2! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testPublishing
	| browser |
	browser := GLMTabulator new.
	browser column: #classes.
	browser sendToOutside: #selectedClass from: #classes -> #selection.
	browser sendTo: #classes -> #highlight fromOutside: #highlightedClass.
	(browser panes first port: #selection) value: 42.
	self assert: (browser pane port: #selectedClass) value equals: 42.
	self assert: (browser panes first port: #selection) value equals: 42.
	(browser pane port: #highlightedClass) value: 43.
	self assert: (browser pane port: #highlightedClass) value equals: 43.
	self assert: (browser panes first port: #highlight) value equals: 43.
	(browser panes first port: #highlight) value: 44.
	self assert: (browser pane port: #highlightedClass) value equals: 43.
	self assert: (browser panes first port: #highlight) value equals: 44.
	(browser pane port: #selectedClass) value: 45.
	self assert: (browser pane port: #selectedClass) value equals: 45.
	self assert: (browser panes first port: #selection) value equals: 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 1/2/2012 01:48'!
testPublishingToOutsideAndInsideFinder
	| innerBrowser finder realInnerBrowser |
	finder := GLMFinder new.
	innerBrowser := GLMTabulator new.
	innerBrowser
		column: #one;
		column: #two.
	innerBrowser
		transmit to: #one;
		andShow: [ :a | a list display: [ :x | 1 to: 43 ] ].
	innerBrowser
		transmit to: #two;
		from: #one;
		andShow: [ :a | a text ].
	innerBrowser transmit toOutsidePort: #selection; from: #one port: #selection.
	finder show: [:a | a custom: innerBrowser].
	self assert: innerBrowser transmissions size equals: 3.
	self assert: innerBrowser transmissions second origins first pane == innerBrowser panes first.
	self assert: innerBrowser transmissions second destination pane == innerBrowser panes last.
	finder startOn: 43.
	realInnerBrowser := innerBrowser.
	self assert: realInnerBrowser transmissions size equals: 3.
	self assert: realInnerBrowser transmissions second origins first pane == realInnerBrowser panes first.
	self assert: realInnerBrowser transmissions second destination pane == realInnerBrowser panes last! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 1/2/2012 01:48'!
testPublishingToOutsideFinder
	| innerBrowser finder |
	finder := GLMFinder new.
	innerBrowser := GLMTabulator new.
	innerBrowser column: #any.
	innerBrowser
		transmit to: #any;
		andShow: [ :a | a list display: [ :x | 1 to: 43 ] ].
	innerBrowser transmit toOutsidePort: #selection; from: #any port: #selection.
	finder show: [:a | a custom: innerBrowser].
	finder startOn: 43.
	self assert: (finder panes first port: #entity) value equals: 43.
	self assert: (finder panes first port: #selection) value isNil.
	((finder panes first presentations first paneNamed: #any) port: #selection) value: 42.
	self assert: (finder panes first port: #selection) value equals: 42.
	self assert: (finder panes first port: #entity) value equals: 43.
	self assert: finder panes size equals: 2.
	self assert: (finder panes last port: #entity) value equals: 42.
	self assert: (finder panes first presentations first isKindOf: GLMTabulator).
	self assert: (finder panes last presentations first isKindOf: GLMTabulator).
	self assert: (finder panes first presentations first isKindOf: GLMTabulator)! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testReferences
	| browser pane1 |
	browser := GLMExplicitBrowser new.
	pane1 := browser addNewPaneNamed: #pane1.
	self assert: (browser resolveOriginPort: #pane1) == (pane1 port: #selection).
	self assert: (browser resolveOriginPort: #pane1 -> #foo) == (pane1 port: #foo).
	self assert: (browser resolveDestinationPort: #pane1) == (pane1 port: #entity).
	self assert: (browser resolveDestinationPort: #pane1 -> #foo) == (pane1 port: #foo).
	self assert: ((browser resolveOriginPort: #outer) isKindOf: GLMPresentationBoundPort).
	self assert: (browser resolveOriginPort: #outer) presentation == browser.
	self assert: (browser resolveOriginPort: #outer) name equals: #selection.
	self assert: ((browser resolveOriginPort: #outer -> #foo) isKindOf: GLMPresentationBoundPort).
	self assert: (browser resolveOriginPort: #outer -> #foo) presentation == browser.
	self assert: (browser resolveOriginPort: #outer -> #foo) name equals: #foo.
	self assert: ((browser resolveDestinationPort: #outer) isKindOf: GLMPresentationBoundPort).
	self assert: (browser resolveDestinationPort: #outer) presentation == browser.
	self assert: (browser resolveDestinationPort: #outer) name equals: #entity.
	self assert: ((browser resolveDestinationPort: #outer -> #foo) isKindOf: GLMPresentationBoundPort).
	self assert: (browser resolveDestinationPort: #outer -> #foo) presentation == browser.
	self assert: (browser resolveDestinationPort: #outer -> #foo) name equals: #foo! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testScriptingDefaults
	| browser |
	browser := GLMTabulator new.
	browser startOn: 42.
	self assert: browser panes size equals: 1.
	self assert: browser transmissions size equals: 1.
	self assert: browser transmissions first origins first equals: (browser pane port: #entity).
	self assert: browser transmissions first destination equals: (browser panes first port: #entity)! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimpleTransmission
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	browser sendTo: #two -> #port2 from: #one -> #port1.
	self assert: browser transmissions size equals: 1.
	self assert: (browser transmissions first transmissionStrategy isKindOf: GLMNoStrategy).
	self assert: browser transmissions first origins first equals: ((browser paneNamed: #one) port: #port1).
	self assert: browser transmissions first destination equals: ((browser paneNamed: #two) port: #port2)! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimpleTransmissionsToOuter
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser sendTo: #outer -> #increased from: #outer -> #entity with: [ :x | x + 1 ].
	(browser transmit)
		to: #one;
		from: #outer port: #increased;
		andShow: [ :a | a text ].
	browser startOn: 41.
	self assert: ((browser paneNamed: #one) port: #entity) value equals: 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:14'!
testStartTransmission
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	browser
		transmit to: #one;
		andShow: [ :a | a list ].
	self assert: browser transmissions size equals: 1.
	self assert: (browser paneNamed: #one) presentations isEmpty.
	self assert: (browser paneNamed: #two) presentations isEmpty.
	browser startOn: 15.
	self assert: (browser paneNamed: #one) presentations size equals: 1.
	self assert: (browser paneNamed: #two) presentations isEmpty! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:14'!
testStartWithOnlyJumpStart
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	browser
		transmit to: #one;
		andShow: [ :a | a list ].
	browser
		transmit to: #two;
		from: #one;
		andShow: [ :a | a text ].
	self assert: browser transmissions size equals: 2.
	self assert: (browser paneNamed: #one) presentations isEmpty.
	self assert: (browser paneNamed: #two) presentations isEmpty.
	browser startOn: #(15 25 35).
	self assert: (browser paneNamed: #one) presentations size equals: 1.
	self assert: (browser paneNamed: #one) matchingPresentations size equals: 1.
	self assert: (browser paneNamed: #two) presentations isEmpty.
	self assert: (browser paneNamed: #two) matchingPresentations isEmpty! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testThreePanesTransmissions
	| browser two |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	(browser transmit)
		to: #three;
		from: #one;
		passivelyFrom: #two;
		andShow: [ :a | a text display: [ :x :y | two := y ] ].
	self assert: browser transmissions size equals: 1.
	self assert: browser transmissions first passiveOrigins size equals: 1.
	self assert: browser transmissions first activeOrigins size equals: 1.
	((browser paneNamed: #two) port: #selection) value: 15.
	self assert: ((browser paneNamed: #two) port: #selection) value equals: 15.
	self assert: ((browser paneNamed: #three) port: #entity) value isNil.
	((browser paneNamed: #one) port: #selection) value: 20.
	self assert: ((browser paneNamed: #one) port: #selection) value equals: 20.
	self assert: ((browser paneNamed: #three) port: #entity) value first equals: 20.
	self assert: ((browser paneNamed: #three) port: #entity) value last equals: 15! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:14'!
testTransmissionWithTwoOrigins
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	browser
		transmit to: #three;
		from: #one;
		from: #two;
		andShow: [ :a | a text ].
	((browser paneNamed: #one) port: #selection) value: 42.
	self assert: ((browser paneNamed: #three) port: #entity) value first equals: 42.
	self assert: ((browser paneNamed: #three) port: #entity) value last equals: nil.
	self assert: (browser paneNamed: #three) presentations size equals: 1.
	self assert: (browser paneNamed: #three) matchingPresentations size equals: 0.
	((browser paneNamed: #two) port: #selection) value: 43.
	self assert: ((browser paneNamed: #three) port: #entity) value first equals: 42.
	self assert: ((browser paneNamed: #three) port: #entity) value last equals: 43.
	self assert: (browser paneNamed: #three) matchingPresentations size equals: 1! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:13'!
testTwoTransmissionsWithOnlyOneEvent
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	browser
		transmit to: #two;
		from: #one;
		andShow: [ :a | a list ].
	browser
		transmit to: #three;
		from: #two;
		andShow: [ :a | a text ].
	self assert: browser transmissions size equals: 2.
	self assert: (browser paneNamed: #one) presentations isEmpty.
	self assert: (browser paneNamed: #two) presentations isEmpty.
	self assert: (browser paneNamed: #three) presentations isEmpty.
	((browser paneNamed: #one) port: #selection) value: 42.
	self assert: ((browser paneNamed: #two) port: #entity) value equals: 42.
	self assert: (browser paneNamed: #one) presentations isEmpty.
	self assert: (browser paneNamed: #two) presentations size equals: 1.
	self assert: (browser paneNamed: #two) matchingPresentations size equals: 1.
	self assert: (browser paneNamed: #three) presentations isEmpty.
	self assert: (browser paneNamed: #three) matchingPresentations isEmpty! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testUpdateAction
	| browser |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list populate: #foo on: $m with: [ :list :input | 42 ] ].
	(browser transmit)
		to: #two;
		from: #one port: #foo;
		andShow: [ :a | a text ].
	browser startOn: #(1 2 3).
	self assert: browser panes first presentations size equals: 1.
	self assert: browser panes last presentations isEmpty.
	browser panes first presentations first actions first actOn: browser panes first presentations first.
	self assert: browser panes second presentations size equals: 1.
	self assert: browser panes second presentations first entity equals: 42! !

!GLMScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2011 19:13'!
testUpdateYourselfOn

	| announcer entity browser presentation |
	announcer := Announcer new.
	entity := OrderedCollection with: 1 with: 2 with: 3.
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a |
		presentation := a list 
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true ].
	browser startOn: entity.
	presentation registerAnnouncements.
	presentation selection: 3.
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: presentation selection isNil ! !

TestCase subclass: #GLMTabulatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMTabulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testComplex
	| layout |
	layout := GLMTabulator new.
	layout
		addColumn: [ :column | 
			column addRow: #second.
			column addRow: #third.
			column addRow: #fourth.
			column
				addRow: [ :row | 
					row addColumn: #fifth.
					row addColumn: #sixth ] ].
	layout addColumn: #first.
	self assert: layout cell children size equals: 2.
	self assert: layout cell children first children size equals: 4.
	self assert: layout cell children first children last children size equals: 2! !

!GLMTabulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testOneSimpleColumnAndOneNested
	| layout |
	layout := GLMTabulator new.
	layout
		addColumn: [ :column | 
			column addRow: #second.
			column addRow: #third.
			column addRow: #fourth ].
	layout addColumn: #first.
	self assert: layout cell children size equals: 2.
	self assert: layout cell children first children size equals: 3! !

!GLMTabulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testOneSimpleRowAndOneNested
	| layout |
	layout := GLMTabulator new.
	layout addRow: #first.
	layout
		addRow: [ :row | 
			row addColumn: #second.
			row addColumn: #third.
			row addColumn: #fourth ].
	self assert: layout cell children size equals: 2.
	self assert: layout cell children last children size equals: 3! !

!GLMTabulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimpleColumns
	| layout |
	layout := GLMTabulator new.
	layout addColumn: #first.
	layout addColumn: #second.
	self assert: layout cell children size equals: 2! !

!GLMTabulatorTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimpleRows
	| layout |
	layout := GLMTabulator new.
	layout addRow: #first.
	layout addRow: #second.
	self assert: layout cell children size equals: 2.
	self assert: layout cell isColumn.
	self assert: layout cell children first isRow! !

TestCase subclass: #GLMTextPresentationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMTextPresentationTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 11:13'!
expectedFailures

	^ #(testTextPortIsPopulatedByDefault)! !

!GLMTextPresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSelectedText
	| presentation |
	presentation := GLMTextPresentation new.
	self assert: presentation selectedText equals: ''.
	presentation selectedTextBlock: [ 'selection' ].
	self assert: presentation selectedText equals: 'selection'! !

!GLMTextPresentationTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 08:58'!
testTextPortIsPopulatedByDefault
	| composite |
	composite := (GLMCompositePresentation new with: [:a | a text ]) startOn: '42'.
	self assert: composite presentations first text equals: '42'! !

TestCase subclass: #GLMTransmissionContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMTransmissionContextTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testCopy
	| context copy |
	context := GLMTransmissionContext new.
	context addPort: GLMSimplePort new.
	copy := context copy.
	self assert: copy ~~ context.
	self assert: copy ports equals: context ports.
	self assert: copy ports ~~ context ports! !

!GLMTransmissionContextTest methodsFor: 'tests' stamp: 'tg 12/19/2009 00:26'!
testForbiddenAnnouncements
	| context pane |
	context := GLMTransmissionContext new.
	pane := GLMPane new.
	self assert: (context canAnnounceMatchingPresentationsChanged: pane).
	context forbidToAnnounceMatchingPresentationsChanged: pane.
	self assert: (context canAnnounceMatchingPresentationsChanged: pane) not! !

!GLMTransmissionContextTest methodsFor: 'tests' stamp: 'tg 12/19/2009 00:07'!
testInclues
	| context port |
	port := GLMSimplePort new.
	context := GLMTransmissionContext new.
	context addPort: port.
	self assert: (context includesPort: port)! !

TestCase subclass: #GLMTransmissionScriptingTest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMTransmissionScriptingTest methodsFor: 'running' stamp: 'tg 11/3/2010 13:23'!
setUp
	browser := GLMExplicitBrowser new.
	browser addPane: (GLMPane new name: #one).
	browser addPane: (GLMPane new name: #two).
	browser addPane: (GLMPane new name: #three).
! !

!GLMTransmissionScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testFrom
	browser transmit from: #one.
	self assert: browser transmissions first origins first pane equals: browser panes first.
	self assert: browser transmissions first origins first name equals: GLMPortIdentifier defaultOriginPortName! !

!GLMTransmissionScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testFromPort
	browser transmit from: #one port: #port.
	self assert: browser transmissions first origins first pane equals: browser panes first.
	self assert: browser transmissions first origins first name equals: #port! !

!GLMTransmissionScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testTo
	browser transmit to: #one.
	self assert: browser transmissions first destination pane equals: browser panes first.
	self assert: browser transmissions first destination name equals: GLMPortIdentifier defaultTargetPortName! !

!GLMTransmissionScriptingTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testToPort
	browser transmit to: #one port: #port.
	self assert: browser transmissions first destination pane equals: browser panes first.
	self assert: browser transmissions first destination name equals: #port! !

!GLMTransmissionScriptingTest methodsFor: 'tests' stamp: 'TudorGirba 5/21/2012 00:04'!
testToWatcher
	browser transmit toWatcher.
	self assert: browser transmissions first destination pane equals: browser watcherPane! !

TestCase subclass: #GLMTransmissionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testBundleStrategy
	| pane1 pane2 transmission presentation |
	pane1 := GLMPane named: 'pane1'.
	pane2 := GLMPane named: 'pane2'.
	transmission := GLMTransmission new.
	transmission ensureReplacePresentationsStrategy.	"ensureNoOverrideBundleStrategy"
	transmission addActiveOrigin: (pane1 port: #port1).
	transmission destination: (pane2 port: #port2).
	transmission addPresentation: GLMPresentation new.
	(pane1 port: #port1) value: 1.
	transmission transmit.
	self assert: pane2 presentations size equals: 1.
	presentation := pane2 presentations first.
	(pane1 port: #port1) value: 2.
	transmission transmit.
	self assert: pane2 presentations first rootPrototype equals: presentation rootPrototype.
	self assert: pane2 presentations first ~~ presentation! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 17:50'!
testCopy
	| transmission port1 port2 newTransmission |
	transmission := GLMTransmission new.
	port1 := GLMSimplePort new.
	port2 := GLMSimplePort new.
	transmission destination: port2.
	transmission addActiveOrigin: port1.
	newTransmission := transmission copy.
	self assert: newTransmission destination ~~ transmission destination.
	self assert: newTransmission origins first ~~ transmission origins first.! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testDefaultStrategy
	self assert: GLMTransmission new transmissionStrategy class equals: GLMNoStrategy! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testNoOverrideStrategy
	| pane1 pane2 transmission presentation |
	pane1 := GLMPane named: 'pane1'.
	pane2 := GLMPane named: 'pane2'.
	transmission := GLMTransmission new.
	transmission ensurePresentIfNoneStrategy.
	transmission addActiveOrigin: (pane1 port: #port1).
	transmission destination: (pane2 port: #port2).
	transmission addPresentation: GLMPresentation new.
	self assert: transmission presentations size equals: 1.
	self assert: transmission destination pane == pane2.
	self assert: transmission transmissionStrategy transmission == transmission.
	(pane1 port: #port1) value: 1.
	transmission transmit.
	self assert: pane2 presentations size equals: 1.
	presentation := pane2 presentations first.
	self assert: transmission destination pane == pane2.
	(pane1 port: #port1) value: 2.
	transmission transmit.
	self assert: pane2 presentations first rootPrototype equals: presentation rootPrototype.
	self assert: pane2 presentations first == presentation! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testSimple
	| pane1 pane2 transmission |
	pane1 := GLMPane named: 'test1'.
	pane2 := GLMPane named: 'test2'.
	transmission := (GLMTransmission new)
		addActiveOrigin: (pane1 port: #output);
		destination: (pane2 port: #input);
		yourself.
	(pane1 port: #output) value: 42.
	self assert: (pane1 port: #output) value equals: 42.
	self assert: (pane2 port: #input) value equals: nil.
	transmission transmit.
	self assert: (pane1 port: #output) value equals: 42.
	self assert: (pane2 port: #input) value equals: 42! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 1/31/2010 01:40'!
testTriggerConditions 
	"Tests that the transmission is triggered only when the origin changes." 
	
	| transmission port1 port2 | 
	transmission := GLMTransmission new. 
	port1 := GLMSimplePort new name: #port1. 
	port2 := GLMSimplePort new name: #port2. 
	transmission addActiveOrigin: port1. 
	transmission destination: port2. 
	self assert: (transmission originatesAt: port1). 
	self assert: (transmission originatesAt: port2) not. 
	self assert: (transmission originatesAt: GLMPort new) not! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'tg 1/17/2010 16:15'!
testTriggerConditionsWithParentPort 
	| transmission presentation | 
	transmission := GLMTransmission new. 
	presentation := GLMPresentation new. 
	transmission addActiveOrigin: 
			((GLMPresentationBoundPort new) 
				presentation: presentation; 
				name: #port1; 
				yourself). 
	self assert: (transmission originatesAt: 
					((GLMPresentationBoundPort new) 
						presentation: presentation; 
						name: #port1; 
						yourself)). 
	self assert: (transmission originatesAt: (presentation pane port: #port1))! !

!GLMTransmissionTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testWhenCondition
	"Tests that the transmission is triggered only when the origin changes."

	| transmission port1 port2 |
	transmission := GLMTransmission new.
	port1 := (GLMSimplePort new)
		name: #port1;
		value: #value1.
	port2 := GLMSimplePort new name: #port2.
	transmission addActiveOrigin: port1.
	transmission destination: port2.
	transmission condition: [ :entity | entity = #value1 ].
	self assert: transmission meetsCondition.
	transmission transmit.
	self assert: port2 value equals: #value1! !

TestCase subclass: #GLMTreePresentationTest
	instanceVariableNames: 'pane presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMTreePresentationTest methodsFor: 'tests' stamp: 'tg 11/15/2009 23:53'!
setUp
	pane := GLMPane named: 'test'.
	presentation := GLMTreePresentation new.
	pane addPresentation: presentation.
	presentation entity: #(($a $b $c $d) ($e $f) ($g)).
	presentation children: [:x :i | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new]].
	presentation shouldValidate: true.! !

!GLMTreePresentationTest methodsFor: 'tests' stamp: 'tg 11/15/2009 17:06'!
testValidateOn
	self assert: (presentation validate: #($e $f) on: (pane port: #selection)).
	self assert: (presentation validate: $a on: (pane port: #selection)).
	self deny: (presentation validate: $h on: (pane port: #selection))! !

!GLMTreePresentationTest methodsFor: 'tests' stamp: 'DamienCassou 7/19/2011 21:00'!
testValidatePorts
	presentation selection: #($e $f).
	self assert: presentation selection equals: #($e $f).
	presentation selection: $a.
	self assert: presentation selection equals: $a.
	presentation selection: 'wrongSelection'.	"this should be invalid"
	self assert: presentation selection equals: $a! !

TestCase subclass: #GLMWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GLMWrapperTest methodsFor: 'tests' stamp: 'TudorGirba 5/18/2012 22:14'!
testDefaultPane
	| browser |
	browser := GLMWrapper new.
	self assert: browser panes size = 1! !

!GLMWrapperTest methodsFor: 'tests' stamp: 'TudorGirba 5/18/2012 22:23'!
testPresentationsAreInstalled
	| browser |
	browser := GLMWrapper new.
	browser show: [:a | a text ].
	browser startOn: 42.
	self assert: browser panes anyOne presentations size = 1.
	self assert: (browser panes anyOne presentations first isKindOf: GLMTextPresentation).! !

Object subclass: #GlamourousBenchmark
	instanceVariableNames: 'progressBarSize progress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GlamourousBenchmark methodsFor: 'utilities' stamp: 'TudorGirba 7/29/2011 18:59'!
defaultBrowser 
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.

	browser transmit to: #one; andShow: [ :a |
		a list
			display: [:x | 1 to: x * 3] ].
	browser transmit to: #two; from: #one; andShow: [ :a |
		a list
			display: [:x | 1 to: x * 3] ].
	browser transmit to: #one; from: #two; andShow: [ :a |
		a list
			display: [:x | 1 to: x * 3] ].

	^ browser! !

!GlamourousBenchmark methodsFor: 'utilities' stamp: 'tg 1/22/2010 21:31'!
defaultFinderBrowser 
	"
	self new defaultFinderBrowser openOn: 10
	"
	| finder |
	finder := GLMFinder new.
	finder list
		title: 'title';
		display: [:each | 1 to: each ];
		showOnly: 50.

	^ finder! !

!GlamourousBenchmark methodsFor: 'utilities' stamp: 'Alexandre Bergel 10/23/2009 09:50'!
measureOpeningTime
	| browser numberOfOpenings time |
	numberOfOpenings := 15.

	browser := self defaultBrowser.
	time := Time millisecondsToRun: [ numberOfOpenings timesRepeat: [(browser openOn: 10) delete] ].
	^ {numberOfOpenings . time}! !

!GlamourousBenchmark methodsFor: 'utilities' stamp: 'Alexandre Bergel 10/23/2009 09:57'!
measureSelectionTime
	"
	self new measureSelectionTime 
	"
	^ self measureSelectionTimeForSize: 1000! !

!GlamourousBenchmark methodsFor: 'utilities' stamp: 'Alexandre Bergel 10/23/2009 10:04'!
measureSelectionTimeForSize: size
	"
	self new measureSelectionTime 
	"
	| browser numberOfSelections time port window |
	numberOfSelections := 15.

	browser := self defaultBrowser.
	window := browser openOn: size.
	port := browser panes first ports second.
	time := Time millisecondsToRun: [ (size - numberOfSelections) to: size do: [:i | port value: i ] ].
	window delete.
	^ {size . time}! !

!GlamourousBenchmark methodsFor: 'utilities' stamp: 'lr 6/4/2010 14:50'!
measureSelectionTimeInFinderForSize: size
	"
	self new measureSelectionTimeInFinderForSize: 20 
	"
	| browser time window |

	browser := self defaultFinderBrowser.
	window := browser openOn: size.
	
	time := Time millisecondsToRun: 
			[size timesRepeat: [ (window model panes last port: #selection) value: size].].
		
	window delete.
	^ {size . time}! !

!GlamourousBenchmark methodsFor: 'utilities' stamp: 'TudorGirba 7/29/2011 18:59'!
showOnlyBrowser 
	| browser |
	browser := GLMTabulator new.
	browser column: #one; column: #two.

	browser transmit to: #one; andShow: [ :a |
		a list
			display: [:x | 1 to: x * 3];
			showOnly: 50].
	browser transmit to: #two; from: #one; andShow: [ :a |
		a list
			display: [:x | 1 to: x * 3];
			showOnly: 50].
	browser transmit to: #one; from: #two; andShow: [ :a |
		a list
			display: [:x | 1 to: x * 3];
			showOnly: 50].

	^ browser! !

!GlamourousBenchmark methodsFor: 'utilities' stamp: 'tg 1/23/2010 00:54'!
showOnlyFinderBrowser 
	"
	self new showOnlyFinderBrowser openOn: 10
	"
	| finder |
	finder := GLMFinder new.
	finder list
		title: 'title';
		display: [:each | 1 to: each ];
		showOnly: 50.

	^ finder! !

Object subclass: #GlamourousHealth
	instanceVariableNames: 'progressBarSize progress progressBarCurrentValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Core'!

!GlamourousHealth classSide methodsFor: 'utilities' stamp: 'Alexandre Bergel 10/23/2009 09:03'!
produceReport
	^ self new produceReport! !

!GlamourousHealth methodsFor: 'progress bar' stamp: 'Alexandre Bergel 10/23/2009 11:32'!
displayProgressBar: aBlock size: size titled: title

	progressBarCurrentValue := 1.
	title
		displayProgressAt: Display center
		from: 0 to: size
		during: [:bar | aBlock value: bar ]
! !

!GlamourousHealth methodsFor: 'progress bar' stamp: 'Alexandre Bergel 10/23/2009 11:32'!
incrProgressBar: bar
	progressBarCurrentValue :=  progressBarCurrentValue + 1.
	bar value: progressBarCurrentValue.
! !

!GlamourousHealth methodsFor: 'logging' stamp: 'Alexandre Bergel 10/23/2009 09:01'!
log: object named: title
	| selectorName source newSource |
	selectorName := (#log, title) asSymbol.
	(self class includesSelector: selectorName)
		ifFalse: [ self class compile: selectorName, String cr, String cr, '	^ #()', String cr.
					  self class organization classify: selectorName under: 'logging'].

	source := (self class >> selectorName) getSourceFromFile.
	newSource := source , '	,#(#(', object printString, ' ''', title, '''))'.
	self class compile: newSource.! !

!GlamourousHealth methodsFor: 'logging' stamp: 'AlexandreBergel 10/26/2009 17:39'!
logMethodCoverage

	^ #()
	,#(#(0 'MethodCoverage'))	,#(#(86.0 'MethodCoverage'))	,#(#(86.0 'MethodCoverage'))	,#(#(84.31 'MethodCoverage'))	,#(#(84.31 'MethodCoverage'))	,#(#(84.31 'MethodCoverage'))	,#(#(83.49 'MethodCoverage'))	,#(#(83.49 'MethodCoverage'))	,#(#(83.49 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(80.37 'MethodCoverage'))	,#(#(77.47 'MethodCoverage'))	,#(#(76.78 'MethodCoverage'))	,#(#(76.78 'MethodCoverage'))	,#(#(76.78 'MethodCoverage'))	,#(#(76.99 'MethodCoverage'))	,#(#(76.99 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(76.31 'MethodCoverage'))	,#(#(0.0 'MethodCoverage'))	,#(#(0.0 'MethodCoverage'))	,#(#(33.07 'MethodCoverage'))	,#(#(33.02 'MethodCoverage'))	,#(#(33.02 'MethodCoverage'))	,#(#(32.98 'MethodCoverage'))	,#(#(32.98 'MethodCoverage'))	,#(#(33.46 'MethodCoverage'))	,#(#(33.46 'MethodCoverage'))! !

!GlamourousHealth methodsFor: 'util' stamp: 'Alexandre Bergel 10/23/2009 10:35'!
openMondrianGraphOn: associations titled: titleAsString

	^ self openMondrianGraphOn: associations titled: titleAsString scaleX: 0.10! !

!GlamourousHealth methodsFor: 'util' stamp: 'Alexandre Bergel 10/23/2009 10:35'!
openMondrianGraphOn: associations titled: titleAsString scaleX: scaleXFactor

	| view |
	view := MOViewRenderer new.


	view node: #foo forIt: [
		view layout: (MOScatterplotLayout new x: #key; y: #value; scaleFactorX: scaleXFactor; scaleFactorY: 0.10 "; upSideDown").
		view interaction popupText: [:element | element key printString, ' nodes => ', element value printString, ' ms' ].
		view nodes: associations.
	
	].
	view open! !

!GlamourousHealth methodsFor: 'util' stamp: 'Alexandre Bergel 10/23/2009 09:03'!
openWorkspaceWith: stream
	Workspace new contents: (stream contents); openLabel: 'Glamour health report'.! !

!GlamourousHealth methodsFor: 'public' stamp: 'Alexandre Bergel 10/23/2009 12:46'!
produceReport
	"
	self new produceReport
	"
	| stream |
	stream := WriteStream on: String new.
	self writeGeneralInfoOn: stream.
	self writeOpeningMeasurementsOn: stream.
	self writeSelectionMeasurementsOn: stream.
	self writeSelectionInFinderMeasurementsOn: stream.
	self writeCoverageInfoOn: stream.
	
	self openWorkspaceWith: stream.
! !

!GlamourousHealth methodsFor: 'public' stamp: 'lr 6/4/2010 14:04'!
viewTestCoverage
	"
	GlamourousHealth new viewTestCoverage
	"
	| typeClass coverage |
	typeClass := Smalltalk 
		at: #CoveragePackageSpy
		ifAbsent: 
			[ self inform: 'The coverage is realized by the tool Spy. Please download it from www.squeaksource.com/Spy.html . Skip the coverage by pressing OK'.
			^ self ].
	coverage := typeClass forPackagesMatching: 'Glamour*'.
	coverage viewBasic! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'lr 6/4/2010 14:04'!
writeCoverageInfoOn: stream 
	| typeClass ratioCoveredMethods lastCoverage diff diffAsString |
	typeClass := Smalltalk 
		at: #CoveragePackageSpy
		ifAbsent: 
			[ self inform: 'The coverage is realized by the tool Spy. Please download it from www.squeaksource.com/Spy.html . Skip the coverage by pressing OK'.
			^ self ].
	self 
		displayProgressBar: 
			[ :bar | 
			ratioCoveredMethods := (typeClass 
				forPackagesMatching: 'Glamour*'
				atEachTestEvaluate: [ self incrProgressBar: bar ]) ratioCoveredMethods ]
		size: (typeClass numberOfTestUnitClassesInPackagesMatching: 'Glamour*')
		titled: 'Running test for coverage'.
	stream
		nextPutAll: ratioCoveredMethods printString , '  % of methods are covered';
		cr.
	lastCoverage := self logMethodCoverage last first.
	diff := ratioCoveredMethods - lastCoverage.
	diff := ((diff * 100) asInteger / 100) asFloat.
	diffAsString := diff > 0 
		ifTrue: [ '+' , diff printString ]
		ifFalse: [ diff printString ].
	stream nextPutAll: 'Progress from last time: ' , diffAsString , ' %'.
	stream cr.
	self 
		log: ratioCoveredMethods
		named: 'MethodCoverage'! !

!GlamourousHealth methodsFor: 'util' stamp: 'Alexandre Bergel 10/23/2009 09:44'!
writeDelimitationOn: stream
	stream nextPutAll: '------------------'; cr! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'lr 6/4/2010 14:04'!
writeGeneralInfoOn: stream
	stream nextPutAll: 'Report produced on ', DateAndTime now printString; cr.
	MCWorkingCopy allManagers detect: [:m | m package name beginsWith: 'Glamour-Tests' ].! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'Alexandre Bergel 10/23/2009 11:37'!
writeOpeningMeasurementsOn: stream
	| res |
	self writeDelimitationOn: stream.
	stream nextPutAll: 'Opening Browser Benchmark:'; cr.

	self displayProgressBar: [:bar | 
		res := GlamourousBenchmark new measureOpeningTime.
		stream nextPutAll: res first printString, ' openings => ', res second printString, ' ms'; cr.
		self incrProgressBar: bar.
		]
		size: 1
		titled: 'Opening'.
	
	self writeDelimitationOn: stream.
	stream cr.! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'AlexandreBergel 10/26/2009 17:38'!
writeSelectionInFinderMeasurementsOn: stream
	| res browserSizes bench associations title |
	browserSizes := #(1 5 10 15 20 25 30 35 40 45 50).
	self writeDelimitationOn: stream.

	title := 'Selecting in finder item Benchmark'.
	stream nextPutAll: title; cr.

	associations := OrderedCollection new.
	bench := GlamourousBenchmark new.
	
	self 
		displayProgressBar:
			[:bar | 
				browserSizes do: [: size |
					res := bench 	measureSelectionTimeInFinderForSize: size.
					stream nextPutAll: res first printString, ' size and selections => ', 
											res second printString, ' ms'; cr.
					associations add: (res first -> res second).
					self incrProgressBar: bar.
			]]
		size: browserSizes size 
		titled: title.
	

	self openMondrianGraphOn: associations titled: title scaleX: 1.0.
	
	
	self writeDelimitationOn: stream.
	stream cr.! !

!GlamourousHealth methodsFor: 'report producers' stamp: 'AlexandreBergel 10/26/2009 17:37'!
writeSelectionMeasurementsOn: stream
	| res browserSizes bench associations title |
	browserSizes := #(100 200 300 400 500 600 700 800 900 1000 1500 2000).
	self writeDelimitationOn: stream.

	title := 'Selecting Item in Browser Benchmark'.
	stream nextPutAll: title; cr.

	associations := OrderedCollection new.
	bench := GlamourousBenchmark new.
	self 
		displayProgressBar:
			[:bar | 
				browserSizes do: [: size |
					res := bench measureSelectionTimeForSize: size.
					stream nextPutAll: res first printString, ' size and selections => ', 
										res second printString, ' ms'; cr.
					associations add: (res first -> res second).
					self incrProgressBar: bar.
			]]
		size: browserSizes size
		titled: title.

	self openMondrianGraphOn: associations titled: title.	
	self writeDelimitationOn: stream.
	stream cr.! !
